/* 
   @(#)gtistat.c	1.22.1.24
*/

/************************************************************************/
/* TSM     Application Code                                             */
/* (C) Copyright 1996-2003 by GlobeSpan Technologies Inc                */
/************************************************************************/

#include "gti.h"
#ifndef GTI_BUILD_DSP_SEPERATE
#include "gti_rel.h"
#endif
#include "gtiextn.h"
#include "gti_sym.h"
#ifdef GTI_HOST_SASSTATUS
#include "gtihrel.h"
#endif

#if (  (defined(GTI_DSPVIKING) && (defined(GTI_HOSTVSC))) )
#include "gti_fw_rel.h"
#endif

#ifdef GTI_DEBUG
#include "p3hw.h"
#include "extern.h"
#include "global.h"
#endif

GTI_WORD Gti_GetBinaryStatus(GTI_XCVR_INFO *,  GTI_WORD , GTI_WORD *, GTI_WORD );


#ifdef __BORLANDC__
#pragma option -zECONST -zFCONST -zHCONST
#endif

    GTI_WORD GTI_CONST_QUAL GTI_ADDRESS_QUAL Margin_Per_Bin_Trans[16] =
    {
        0,   0,   7,  11,  16,  23,  33,  46,
        66, 93, 132, 186, 264, 373, 527, 746
    };

    GTI_WORD GTI_CONST_QUAL GTI_ADDRESS_QUAL Avrg_Margin_Trans[] =
    {
        0xEFC0, 0xE256, 0xD5AD, 0xC9B9, 0xBE70, 0xB3C9, 0xA9BB, 0xA03C,
        0x9745, 0x8ECF, 0x86D2, 0x7F47, 0x7828, 0x7170, 0x6B17, 0x651A,
        0x5F72, 0x5A1B, 0x5511, 0x504E, 0x4BD0, 0x4793, 0x4392, 0x3FCA,
        0x3C39, 0x38DA, 0x35AC, 0x32AB, 0x2FD6, 0x2D29, 0x2AA2, 0x283F,
        0x25FF, 0x23DF, 0x21DD, 0x1FF8, 0x1E2E, 0x1C7E, 0x1AE6, 0x1965,
        0x17F9, 0x16A2, 0x155E, 0x142C, 0x130B, 0x11FA, 0x10F9, 0x1006,
        0x0F20, 0x0E47, 0x0D7B, 0x0CBA, 0x0C04, 0x0B58, 0x0AB5, 0x0A1C,
        0x098B, 0x0902, 0x0881, 0x0807, 0x0794, 0x0728, 0x06C1, 0x0661,
        0x0605, 0x05AF, 0x055E, 0x0511, 0x04C8, 0x0484, 0x0443, 0x0406,
        0x03CC, 0x0396, 0x0362, 0x0332, 0x0304, 0x02D9, 0x02B0, 0x028A,
        0x0265, 0x0243, 0x0223, 0x0204, 0x01E7, 0x01CC, 0x01B2, 0x019A,
        0x0183, 0x016D, 0x0159, 0x0145, 0x0133, 0x0122, 0x0112, 0x0102,
        0x00F4, 0x00E6, 0x00D9, 0x00CD, 0x00C2, 0x00B7, 0x00AC, 0x00A3,
        0x009A, 0x0091, 0x0089, 0x0081, 0x007A, 0x0073, 0x006D, 0x0067,
        0x0061, 0x005B, 0x0056, 0x0051, 0x004D, 0x0048, 0x0044, 0x0041,
        0x003D, 0x0039, 0x0036, 0x0033, 0x0030, 0x002E, 0x002B, 0x0029,
        0x0026, 0x0024, 0x0022, 0x0020, 0x001E, 0x001D, 0x001B, 0x0019,
        0x0018, 0x0017, 0x0015, 0x0014, 0x0013, 0x0012, 0x0011, 0x0010,
        0x000F, 0x000E, 0x000D, 0x000C, 0x000C, 0x000B, 0x000A, 0x000A,
        0x0009, 0x0009, 0x0008, 0x0008, 0x0007, 0x0007,
    };

   GTI_WORD GTI_CONST_QUAL GTI_ADDRESS_QUAL Snr_Conv_Trans[] =
    {
        0x0000, 0x0017, 0x0020, 0x0027, 0x002D, 0x0033, 0x0037, 0x003C,
        0x0040, 0x0044, 0x0048, 0x004B, 0x004E, 0x0052, 0x0055, 0x0058,
        0x005B, 0x005D, 0x0060, 0x0063, 0x0065, 0x0068, 0x006A, 0x006D,
        0x006F, 0x0071, 0x0073, 0x0076, 0x0078, 0x007A, 0x007C, 0x007E,
        0x0080, 0x0082, 0x0084, 0x0086, 0x0088, 0x008A, 0x008B, 0x008D,
        0x008F, 0x0091, 0x0093, 0x0094, 0x0096, 0x0098, 0x0099, 0x009B,
        0x009D, 0x009E, 0x00A0, 0x00A2, 0x00A3, 0x00A5, 0x00A6, 0x00A8,
        0x00A9, 0x00AB, 0x00AC, 0x00AE, 0x00AF, 0x00B1, 0x00B2, 0x00B4,
    };

#ifdef __BORLANDC__
#pragma option -zE* -zF* -zH*
#endif

GTI_WORD
GetBitsPerBinStatus(GTI_XCVR_INFO *pSys,                  /* Xcvr pointer     */
            GTI_WORD nStatusType,                         /* Status type      */
            GTI_BYTE *pBuffer,                            /* Data Buffer      */
            GTI_WORD nLength);                            /* Data Buffer Len  */
GTI_WORD
Gti_GetMeanSQStatus(GTI_XCVR_INFO *pSys,                  /* Xcvr pointer     */
            GTI_WORD nStatusType,                         /* Status type      */
            GTI_WORD *pBuffer,                            /* Data Buffer      */
            GTI_WORD nLength);                            /* Data Buffer Len  */
GTI_WORD
Gti_GetMarginPerBinStatus(GTI_XCVR_INFO *pSys,
                      GTI_WORD nStatusType,
                      GTI_WORD *pBuffer,
                      GTI_WORD nLength,
                      char *pAverage);
GTI_WORD
Gti_GetLineDataStatus(GTI_XCVR_INFO *pSys,
                      GTI_LINE_DATA_STATUS_TYPE *pLS,
                      GTI_WORD nLength);
void
Gti_ConvertSnrArray(GTI_BYTE *bArray, GTI_WORD *wBuffer, int nBytes);

void
Gti_ConvertSnrArray(GTI_BYTE *bArray, GTI_WORD *wBuffer, int nBytes)
{
    int i, k;
    GTI_DWORD dwX, dwP;
    GTI_WORD wN, wM, wY, wA, wZ;

    for(k=0, i=0; i < nBytes; i+=3, k++)
    {
        dwX = (bArray[i] >> 4) | ((GTI_DWORD)bArray[i+1] << 4) | ((GTI_DWORD)bArray[i+2] << 12);
        if(dwX == 0)
           dwX = 0x7FFF9;
        wN = (bArray[i] >> 4) & 0x0f;

        for(wM = 0; (dwX < 0x20000); wM++)
        {
            dwX <<= 2;
        }

        dwP = dwX >> 13;

        if(dwP > 64)
            continue;

        wY = Snr_Conv_Trans[dwP];

        wZ = (181 * wY);
        wBuffer[k] = wZ >> (wN + wM);
    }
}


/******************************************************************************/
/* Procedure: GetBitsPerBinStatus               Created: 09.24.98             */
/* ----------------------                                                     */
/* Description: The function retrieves Bits/Bin status by reading DSP memory  */
/*          and filling out the input/output buffer.                          */
/* -------------------------------------------------------------------------- */
GTI_WORD
GetBitsPerBinStatus(GTI_XCVR_INFO *pSys,                  /* Xcvr pointer     */
            GTI_WORD nStatusType,                         /* Status type      */
            GTI_BYTE *pBuffer,                            /* Data Buffer      */
            GTI_WORD nLength)                             /* Data Buffer Len  */
{
    GTI_BYTE bData, baseFDPAddr;
    GTI_WORD bTotalBins, nRetSize, i, nMultFact;
    GTI_WORD nTonesTblLoc, bBinsNumLoc, nTempLoc, nBinNum;
    GTI_BYTE read_blk_data[1536];
    GTI_BYTE start_ram;
    GTI_BYTE bActProject;
    GTI_WORD wSize, wData, wAddress;
    GTI_BYTE bOffset;

    nMultFact = 1;
    bOffset = 0;

    bActProject = GTI_PRIMARY_PROJECT_ID(pSys);
    switch( bActProject )
    {
        case GTI_TYPE_ANNEX_C:
          if(Gti_GetCurrentMode(pSys) == GTI_CO)
          {
            switch(nStatusType)
            {
            case GTI_BIT_LOADING_UP:
                nTonesTblLoc = GTI_RxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_noRxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAMC;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_NEXT_UP:
                nTonesTblLoc = GTI_RxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_noRxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAMC;
                nRetSize = GTI_BIT_LOADING_NEXT_UP_LEN;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_DN:
                nTonesTblLoc = GTI_TxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_noTxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAME;
                nMultFact = 2;
                wSize = 0x200;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else  if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_CENT_LITE_STANDARD)
                   nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            case GTI_BIT_LOADING_NEXT_DN:
                nTonesTblLoc = GTI_TxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_noTxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAM2;
                nMultFact = 2;
                wSize = 0x200;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_CENT_LITE_STANDARD)
                     nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            default:
                return 0;
            }

          }
          else /* CP */
          {
            switch(nStatusType)
            {
            case GTI_BIT_LOADING_UP:
                nTonesTblLoc = GTI_cpTxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_cpnoTxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAMF;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                nMultFact = 2;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_NEXT_UP:
                nTonesTblLoc = GTI_cpTxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_cpnoTxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAMF;
                nRetSize = GTI_BIT_LOADING_NEXT_UP_LEN;
                nMultFact = 2;
                wSize = 0x40;
                break;

            case GTI_BIT_LOADING_DN:
                nTonesTblLoc = GTI_cpRxToneOrdTblFextHost_LOC;
                bBinsNumLoc = GTI_cpnoRxBinsFextHost_LOC;
                start_ram = GTI_FDPSRAMA;
                wSize = 0x100;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_CENT_LITE_STANDARD)
                    nRetSize = 128;
                else if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_RESERVE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            case GTI_BIT_LOADING_NEXT_DN:
                nTonesTblLoc = GTI_cpRxToneOrdTblNextHost_LOC;
                bBinsNumLoc = GTI_cpnoRxBinsNextHost_LOC;
                start_ram = GTI_FDPSRAME;
                wSize = 0x100;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else  if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_CENT_LITE_STANDARD)
                    nRetSize = 128;
                else  if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_RESERVE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
                break;

            default:
                return 0;
            }
          } /* if CO CP */
          break;
    case GTI_TYPE_ANNEX_H:
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            switch(nStatusType)
            {
            case GTI_BIT_LOADING_UP:
                nTonesTblLoc = GTI_RxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_noRxBins_LOC;
                start_ram = GTI_FDPSRAM1;
                nRetSize = 256;
                wSize = 0x100;
                break;

            case GTI_BIT_LOADING_DN:
                nTonesTblLoc = GTI_TxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_noTxBins_LOC;
                start_ram = GTI_FDPSRAM4;
                nMultFact = 2;
                wSize = 0x200;
                nRetSize = 256;
                break;

            default:
                return 0;
            }

        }
        else /* CP */
        {
            switch(nStatusType)
            {
            case GTI_BIT_LOADING_UP:
                nTonesTblLoc = GTI_cpTxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_cpnoTxBins_LOC;
                start_ram = GTI_FDPSRAM4;
                nRetSize = 256;
                nMultFact = 2;
                wSize = 0x200;
                break;

            case GTI_BIT_LOADING_DN:
                nTonesTblLoc = GTI_cpRxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_cpnoRxBins_LOC;
                start_ram = GTI_FDPSRAM1;
                wSize = 0x100;
                nRetSize = 256;
                break;

            default:
                return 0;
            }
        } /* if CO CP */
        break;
      default:
        /* not Annex C or Annex H */
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            if((nStatusType == GTI_BIT_LOADING_UP) || (nStatusType == GTI_BIT_LOADING_NEXT_UP))
            {
                nTonesTblLoc = GTI_RxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_noRxBins_LOC;
                start_ram = GTI_FDPSRAM7;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                wSize = 0x40;
            }
            else
            {
                nTonesTblLoc = GTI_TxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_noTxBins_LOC;
                start_ram = GTI_FDPSRAM4;
                nMultFact = 2;
                wSize = 0x200;

                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
            }
        }
        else     /* CP */
        {
            if((nStatusType == GTI_BIT_LOADING_UP) || (nStatusType == GTI_BIT_LOADING_NEXT_UP))
            {
                nTonesTblLoc = GTI_cpTxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_cpnoTxBins_LOC;
                start_ram = GTI_FDPSRAMC;
                nRetSize = GTI_BIT_LOADING_UP_LEN;
                nMultFact = 2;
                if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_B)
                   wSize = 0x80;
                else
                   wSize = 0x40;
            }
            else
            {
                nTonesTblLoc = GTI_cpRxToneOrdTbl_LOC;
                bBinsNumLoc = GTI_cpnoRxBins_LOC;
                start_ram = GTI_FDPSRAM7;
                wSize = 0x100;
                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD)
                    nRetSize = 128;
                else
                    nRetSize = 256;
            }
        } /* CO or CP */
        break;
    } /* Switch on Annex Type */

    /* If Annex B, the upstream bins need to be shifted up to appear in the correct place */
    if((GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_B ) && (nStatusType == GTI_BIT_LOADING_UP) &&
       (Gti_GetCurrentMode(pSys) == GTI_CO) )
    {
       if(  (GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD) == GTI_ALCTL_STANDARD)
           ||(  ((GTI_WORD)(  GET_HOST_DB_B(pSys, GTI_vndIDBlk+2) 
                           | (GET_HOST_DB_B(pSys, GTI_vndIDBlk+3) << 0x08) ) == GTI_RMT_VENDORID_ALCTL1)
              &&((GTI_WORD)(  GET_HOST_DB_B(pSys, GTI_vndIDBlk+4)
                           | (GET_HOST_DB_B(pSys, GTI_vndIDBlk+5) << 0x08) ) == GTI_RMT_VENDORID_ALCTL2) ))
            bOffset = 24;               /* Alcatel starts at bin 29 */
        else                            /* everyone else is bin 32 */
            bOffset = 31;
    }
    else
        bOffset = 0;
  
    if(nLength < nRetSize)
        return 0;

    for(i = 0; i < nRetSize; i++)
        pBuffer[i] = 0;

    for(i = 0; i < 1536; i++)
        read_blk_data[i] = 0;

    CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);

    baseFDPAddr = (GTI_BYTE)(bBinsNumLoc >> 0x08);

    if( baseFDPAddr < 0x8 )
        baseFDPAddr = (GTI_BYTE)((baseFDPAddr + GTI_FDPSRAM0) | GTI_READ_DSP);
    else
        baseFDPAddr = (GTI_BYTE)((baseFDPAddr + GTI_FDPSRAM8 - 8) | GTI_READ_DSP);

    /* Read total number of bits/bin */
    WRITE_DSP_ADDR(pSys, GTI_DSP_A, (GTI_BYTE)bBinsNumLoc, baseFDPAddr);

    bTotalBins = (GTI_WORD)((READ_DSP_BYTE(pSys, GTI_DSP_A, GTI_EXT_DATA_DSP) >> 0x04) & 0x0f);
    bTotalBins |= (READ_DSP_WORD(pSys, GTI_DSP_A) & 0xff) << 0x04;

    wAddress = MAKEWORD((nTonesTblLoc & 0xff), start_ram);

    i = 0;
    while(wSize > 0)
    {
        if(wSize > (255 - LOBYTE(wAddress)))
            wData = (GTI_WORD)(255 - LOBYTE(wAddress));
        else
            wData = wSize;

        /* if we are reading the last word on the page */
        /* change the mode to non AI  to avoid lockups */

        if((LOBYTE(wAddress)) == 0xff)
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);
            wData = 1;
        }
        else
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_READ_BLOCK_MODE);
        }

        WRITE_DSP_ADDR(pSys, GTI_DSP_A, LOBYTE(wAddress),
            HIBYTE(wAddress)|GTI_READ_DSP);

        READ_DSP_EXT_BLOCK(pSys, GTI_DSP_A, GTI_EXT_DATA_DSP, wData * 3, &read_blk_data[i]);

        wAddress = (GTI_WORD)(wAddress + wData);
        wSize = (GTI_WORD)(wSize - wData);
        i = (GTI_WORD)(i + (wData * 3));
    }

    for(nBinNum = 0, i = 0; i < bTotalBins; i++)
    {
        nTempLoc = (GTI_WORD)(nBinNum * nMultFact);

        /* list 4 bits are a Bits/Bin data */
        bData = (GTI_BYTE) ((read_blk_data[nTempLoc * 3] >> 0x04) & 0x0f);

        wData = (GTI_WORD)((read_blk_data[3 * nTempLoc + 1] | (read_blk_data[3 * nTempLoc + 2] << 8)));

        /* most 8 bits are the next offset */
        nBinNum = (GTI_WORD)(((wData >> 0x08) & 0xff));

        /* add cluster information */
        pBuffer[nBinNum + bOffset] = (bData & 0x3f) | (wData & 0xc0);
    }

    return nRetSize; /* length of a buffer in bytes     */
}

/******************************************************************************/
/* Procedure: Gti_GetMeanSQStatus             Created: 09.24.98               */
/* --------------------------------                                           */
/* Description: The function calculates Signal Quality status                 */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_GetMeanSQStatus(GTI_XCVR_INFO *pSys,                  /* Xcvr pointer     */
            GTI_WORD nStatusType,                         /* Status type      */
            GTI_WORD *pBuffer,                            /* Data Buffer      */
            GTI_WORD nLength)                             /* Data Buffer Len  */
{
    GTI_WORD nRetSize, nWordSize;
    GTI_BYTE bAddress, bMemType, bFullArr[256 * 3];
    int i, k;
    GTI_BYTE bOffset;

    /* Are we CO or CP */
    if(Gti_GetCurrentMode(pSys) == GTI_CO)
    {
        nRetSize = 32;
        if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
        {
            if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                i = GTI_coNSRArrayNextHost_LOC;
            else
                i = GTI_coNSRArrayFextHost_LOC;
        }
        else
        {
             if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_H)
             {
              nRetSize = 255;
              if(!Gti_IsCXfrActive(pSys)) /* if data mode, read RSRAM */
                i = GTI_CO_NSR_FEXT_ADDRESS_LOC;
              else /* if training, read FDPRAM */
                i = GTI_co_NSR_ADR_LOC;
             }
             else
             {
              i = GTI_co_NSR_ADR_LOC;
              if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_B)
                nRetSize = 64;
             }
        }

        bAddress = LOBYTE(i);
        bMemType = HIBYTE(i);
    }
    else  /* CP */
    {
        if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
        {
#ifndef GTI_DSPVIKING
            if(!Gti_IsCXfrActive(pSys)) /* if data mode, read RSRAM */
            {
                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD )
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_NSR_NEXT_ADDRESS_LOC;
                    else
                        i = GTI_NSR_FEXT_ADDRESS_LOC;

                    nRetSize = 128;
                }
                else if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_CENT_LITE_STANDARD)
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_NSR_NEXT_ADDRESS_LOC;
                    else
                        i = GTI_NSR_FEXT_ADDRESS_LOC;

                    nRetSize = 128;
                }
                else
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_NSR_NEXT_ADDRESS_LOC;
                    else
                        i = GTI_NSR_FEXT_ADDRESS_LOC;

                    nRetSize = 256;
                }
            }
            else /* if training, read FDPRAM */
#endif /* !VIKING */
            {
                if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD )
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_cpNSRArrayNextHost_LOC;
                    else
                        i = GTI_cpNSRArrayFextHost_LOC;

                    nRetSize = 128;
                }
                else if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_CENT_LITE_STANDARD )
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_cpNSRArrayNextHost_LOC;
                    else
                        i = GTI_cpNSRArrayFextHost_LOC;

                    nRetSize = 128;
                }
                else if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_RESERVE_STANDARD )
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_cpNSRArrayNextHost_LOC;
                    else
                        i = GTI_cpNSRArrayFextHost_LOC;

                    nRetSize = 128;
                }
                else
                {
                    if((nStatusType == GTI_MEAN_SQ_NEXT_ERROR) || (nStatusType == GTI_SNR_MARGIN_PER_BIN_NEXT))
                        i = GTI_cpNSRArrayNextHost_LOC;
                    else
                        i = GTI_cpNSRArrayFextHost_LOC;

                    nRetSize = 256;
                }
            }
        }
        else /* not Annex C */
        {
         if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_H)
           {
            nRetSize = 256;
            if(!Gti_IsCXfrActive(pSys)) /* if data mode, read RSRAM */
              i = GTI_CP_NSR_FEXT_ADDRESS_LOC;
            else /* if training, read FDPRAM */
              i = GTI_cp_NSR_ADR_LOC;
           }
         else
           {
            if(GET_HOST_DB_B(pSys, GTI_STANDARD) == GTI_G_LITE_STANDARD )
            {
                i = GTI_cp_NSR_ADR_LOC;
                nRetSize = 128;
            }
            else
            {
                i = GTI_cp_NSR_ADR_LOC;
                nRetSize = 256;
            }
           }
        }
        bAddress = LOBYTE(i);
        bMemType = HIBYTE(i);
    }

    /* If Annex B, the upstream bins need to be shifted up to appear in the correct place */
    if((GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_B ) && (Gti_GetCurrentMode(pSys) == GTI_CO))
    {
        if(  (GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD) == GTI_ALCTL_STANDARD)
           ||(  ((GTI_WORD)(  GET_HOST_DB_B(pSys, GTI_vndIDBlk+2) 
                           | (GET_HOST_DB_B(pSys, GTI_vndIDBlk+3) << 0x08) ) == GTI_RMT_VENDORID_ALCTL1)
              &&((GTI_WORD)(  GET_HOST_DB_B(pSys, GTI_vndIDBlk+4)
                           | (GET_HOST_DB_B(pSys, GTI_vndIDBlk+5) << 0x08) ) == GTI_RMT_VENDORID_ALCTL2) ))
            bOffset = 24;               /* Alcatel starts at bin 29 */
        else                            /* everyone else is bin 32 */
            bOffset = 31;
    }
    else
        bOffset = 0;

    if(nLength >= nRetSize)
    {
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_H)
            {
                if( !Gti_IsCXfrActive(pSys) )
                    bMemType = (GTI_BYTE)(bMemType + GTI_IRAM0);
                else
                    bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
            }
            else /* not Annex H*/
                bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
        }
        else /* CP */
        {
            if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
            {
#ifndef GTI_DSPVIKING
                if( !Gti_IsCXfrActive(pSys) )
                    bMemType = (GTI_BYTE)(bMemType + GTI_IRAM0);
                else
#endif /*VIKING*/
                    bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
            }
            else
            {
                if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_H)
                {
                  if( !Gti_IsCXfrActive(pSys) )
                    bMemType = (GTI_BYTE)(bMemType + GTI_IRAM0);
                  else
                    bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
                }
                else /* not Annex C or Annex H */
                  bMemType = (GTI_BYTE)(bMemType + GTI_FDPSRAM0);
            }
        }

        /* Read SQ */
        CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_READ_BLOCK_MODE);
        WRITE_DSP_ADDR(pSys, GTI_DSP_A, bAddress, (GTI_BYTE)(bMemType | GTI_READ_DSP));

        nWordSize = Gti_GetWordSize(bMemType);

        if(nWordSize  == 3)
        {
            READ_DSP_EXT_BLOCK(pSys, GTI_DSP_A, GTI_EXT_DATA_DSP, nRetSize * nWordSize, bFullArr);
        }
        else
        {
            READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_EXT_DATA_DSP, nRetSize * nWordSize, bFullArr);
        }
                                                                                                            /* Clear the array */
        /* clear the array */
        for(i=0; i<nRetSize;i++)
            pBuffer[i] = 0;

 
#ifdef GTI_DSPVIKING
        if( (Gti_GetCurrentMode(pSys) != GTI_CO) && ( (GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_A) || 
                                                      (GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_B) ) )
        {
           Gti_ConvertSnrArray(bFullArr, pBuffer, nRetSize *3 );
        }else
#endif
        {

           for(i=0, k=0; k < nRetSize - bOffset; i+=nWordSize, k++)
           {
            pBuffer[k+bOffset] = MAKEWORD((bFullArr[i + nWordSize - 2]), (bFullArr[i + nWordSize - 1]));

            if(Gti_GetCurrentMode(pSys) != GTI_CO)
            {
                if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
                {
#ifndef GTI_DSPVIKING
                    if( !Gti_IsCXfrActive(pSys) )   /* divide by 8 in data mode only */
                    {
                        if(pBuffer[k] != 0xffff)
                            pBuffer[k] = (GTI_WORD)(pBuffer[k] / 8);
                    }
#endif /*VIKING*/

                }
                else
                {
                  if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_H)
                  {
                    if( !Gti_IsCXfrActive(pSys) )   /* divide by 8 in data mode only */
                    {
                        if(pBuffer[k] != 0xffff)
                            pBuffer[k] = (GTI_WORD)(pBuffer[k] / 4);
                    }
                  }
                }

            }
            else
            {
                if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_H)
                {
                    if( !Gti_IsCXfrActive(pSys) )   /* divide by 8 in data mode only */
                    {
                        if(pBuffer[k] != 0xffff)
                            pBuffer[k] = (GTI_WORD)(pBuffer[k] / 4);
                    }
                }
            }
           }
        }

        return  (GTI_WORD)(nRetSize * 2);

    }
    else
        return 0;
}

/******************************************************************************/
/* Procedure: GetMarginPerBinStatus             Created: 09.24.98             */
/* --------------------------------                                           */
/* Description: The function calculates margin per bin status from SQ status  */
/*          and Bits per Bin status arrays.                                   */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_GetMarginPerBinStatus(GTI_XCVR_INFO *pSys,
                      GTI_WORD nStatusType,
                      GTI_WORD *pBuffer,
                      GTI_WORD nLength,
                      char *pAverage)
{
    GTI_WORD wSQ[256], wData, wAverage = 0, i, k, nUsedBins, nBitLoading;
    GTI_WORD nAvSum = 0,  mOffset = 0, pMarginDiff;
    int nTempData;
    GTI_BYTE bBitsPerBin[256];

    if(pAverage)
        *pAverage = 0;

    switch(nStatusType)
    {

    case GTI_SNR_MARGIN_PER_BIN:
    case GTI_LCL_SNR_MARGIN:

        if(Gti_GetMeanSQStatus(pSys, nStatusType, wSQ, sizeof(wSQ)) == 0)
            return 0;

        if(Gti_GetCurrentMode(pSys) == GTI_CO)
            nBitLoading = GTI_BIT_LOADING_UP;
        else
            nBitLoading = GTI_BIT_LOADING_DN;
        break;

    case GTI_SNR_MARGIN_PER_BIN_NEXT:

        if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
        {
            if(Gti_GetMeanSQStatus(pSys, nStatusType, wSQ, sizeof(wSQ)) == 0)
                return 0;

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                nBitLoading = GTI_BIT_LOADING_NEXT_UP;
            else
                nBitLoading = GTI_BIT_LOADING_NEXT_DN;
        }
        else
        {
            if(Gti_GetMeanSQStatus(pSys, GTI_MEAN_SQ_ERROR, wSQ, sizeof(wSQ)) == 0)
                return 0;

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                nBitLoading = GTI_BIT_LOADING_UP;
            else
                nBitLoading = GTI_BIT_LOADING_DN;
        }
        break;

    default:
        return 0;
    }

    nUsedBins = Gti_SStatusXCVR(pSys, nBitLoading, bBitsPerBin,
        sizeof(bBitsPerBin), GTI_DSP_A);

    if(nUsedBins == 0)
        return 0;

    if(pBuffer && (nLength < (nUsedBins * sizeof(GTI_WORD))))
        return 0;

    for(i=0; i < nUsedBins; i++)
    {
        if(bBitsPerBin[i] != 0)
        {
            wData = (GTI_WORD)((wSQ[i]/4) * (Margin_Per_Bin_Trans[bBitsPerBin[i] & 0xf]));

            if(pAverage)
            {
                nAvSum ++;
                for(k=0; k < sizeof(Avrg_Margin_Trans)/sizeof(GTI_WORD); k++)
                {
                    if(wData > Avrg_Margin_Trans[k])
                    {
                        wAverage = (GTI_WORD)(wAverage + k);
                        break;
                    }
                }
            }
        }
        else
            wData = 0;

        if(pBuffer)
            pBuffer[i] = wData;
    }

    /* Continue with Next average if Annex C DBM */

    if(nStatusType == GTI_LCL_SNR_MARGIN)
    {
        if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
        {
            if(GET_HOST_DB_B(pSys, GTI_ANNEX_C_MODE) == GTI_ANNEX_C_DBM )
            {
                if(Gti_GetMeanSQStatus(pSys, GTI_MEAN_SQ_NEXT_ERROR, wSQ, sizeof(wSQ))== 0)
                    return 0;

                if(Gti_GetCurrentMode(pSys) == GTI_CO)
                    nBitLoading = GTI_BIT_LOADING_NEXT_UP;
                else
                    nBitLoading = GTI_BIT_LOADING_NEXT_DN;

                nUsedBins = Gti_SStatusXCVR(pSys, nBitLoading, bBitsPerBin,
                    sizeof(bBitsPerBin), GTI_DSP_A);

                if(nUsedBins == 0)
                    return 0;

                if(pBuffer && (nLength < (nUsedBins * sizeof(GTI_WORD))))
                    return 0;

                for(i=0; i < nUsedBins; i++)
                {
                    if(bBitsPerBin[i] != 0)
                    {
                        wData = (GTI_WORD)((wSQ[i]/4) * (Margin_Per_Bin_Trans[bBitsPerBin[i] & 0xf]));

                        if(pAverage)
                        {
                            nAvSum ++;
                            for(k=0; k < sizeof(Avrg_Margin_Trans)/sizeof(GTI_WORD); k++)
                            {
                                if(wData > Avrg_Margin_Trans[k])
                                {
                                    wAverage = (GTI_WORD)(wAverage + k);
                                    break;
                                }
                            }
                        }
                    }
                    else
                        wData = 0;

                    if(pBuffer)
                        pBuffer[i] = wData;
                }
            }
        }
    }


    if(pAverage && nAvSum)
    {
        for(i=0; i < nUsedBins; i++)
        {
            if(bBitsPerBin[i] != 0)
            {
                wData = (GTI_WORD)((wSQ[i]/4) * (Margin_Per_Bin_Trans[bBitsPerBin[i] & 0xf]));
                if(pAverage)
                {
                    for(k=0; k < sizeof(Avrg_Margin_Trans)/sizeof(GTI_WORD); k++)
                    {
                        if(wData > Avrg_Margin_Trans[k])
                        {
			    /* margin per bin average in dB */
                            pMarginDiff = (GTI_WORD)(k);
                            break;
                        }
                    }
                    if (pMarginDiff > (wAverage/nAvSum))
                        pMarginDiff = pMarginDiff - wAverage / nAvSum;
                    else
                        pMarginDiff = wAverage / nAvSum - pMarginDiff;
                    mOffset = mOffset + pMarginDiff;
                }
            }
        }
        mOffset = (GTI_WORD)(mOffset / nAvSum);

        nTempData = (int)(wAverage / nAvSum) - 30;
        nTempData = (int)(nTempData - mOffset);

        nTempData = nTempData + ((int)GET_HOST_DB_B(pSys, GTI_ACT_CODING_GAIN2) & 0xff) / 2;

        *pAverage = (char)((nTempData > 127) ? 127 : (char)nTempData);

        wData = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_TRELLIS) |
            ((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_TRELLIS+1)) << 0x08));

        if(wData == GTI_TRELLIS_ENABLE)
        {
            *pAverage += 3;
        }

        if(*pAverage > 7)
        {
            *pAverage -= (char)GET_HOST_DB_B(pSys, GTI_MARGIN_O_D);
            *pAverage += (char)GET_HOST_DB_B(pSys, GTI_MARGIN_O_U);
        }
   	else if (*pAverage > 6)
        {
            *pAverage += 1;
        }
   	else if (*pAverage > 5)
        {
            *pAverage += 0;
        }
        else if (*pAverage > 4)
        {
            *pAverage -= 1;
        }
        else if (*pAverage > 2)
        {
            *pAverage -= 2;
        }
        else
        {
            *pAverage -= 2;
        }
    }

    if(pAverage)
        return GTI_LCL_SNR_MARGIN_LEN;
    else
        return (GTI_WORD)(nUsedBins * sizeof(GTI_WORD));
}

/*****************************************************************************/
/* Procedure: Gti_GetAfeVersion                   Created: 03.24.00          */
/* ----------------------                                                    */
/* Description: The function gets the AFE version from the DSP mem space.    */
/*      Return: BYTE (AFE version number)                                    */
/* ------------------------------------------------------------------------- */
GTI_BYTE
Gti_GetAfeVersion(GTI_XCVR_INFO *pSys)
{
#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)

#define WRITE_DSP_IREG(pSys,bId,bReg,bDataL,bDataH) \
    CONFIGURE_DSP(pSys, bId, GTI_NO_AI);            \
    WRITE_DSP_ADDR(pSys, bId, bReg, GTI_IREGA);     \
    WRITE_DSP_WORD(pSys, bId, bDataL, bDataH);

#define READ_DSP_IREG(pSys,bId,bReg,wRegData)                 \
    CONFIGURE_DSP(pSys, bId, GTI_NO_AI);                      \
    WRITE_DSP_ADDR(pSys, bId, bReg, GTI_IREGA | GTI_READ_DSP);\
    wRegData = READ_DSP_WORD(pSys, bId);
#endif

#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)
    GTI_WORD wResult = 0;
#endif
    GTI_BYTE bReturn = 0;

#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)

    WRITE_DSP_IREG(pSys, GTI_DSP_A, 0x3c, 0x80, 0x8d);
    WRITE_DSP_IREG(pSys, GTI_DSP_A, 0x85, 0x50, 0x09);

    WRITE_DSP_IREG(pSys, GTI_DSP_A, 0x34, 0x80, 0x00);
    READ_DSP_IREG(pSys, GTI_DSP_A, 0x0c, wResult);

    bReturn = (GTI_BYTE)((wResult >> 4) & 0xF);
#else
    (void)pSys;
#endif

    return bReturn;
}

/*****************************************************************************/
/* Procedure: Gti_GetChipVersion                   Created: 03.24.00         */
/* ----------------------                                                    */
/* Description: The function gets the chip version from the DSP mem space.   */
/*      Return: BYTE (chip version number.                                   */
/* ------------------------------------------------------------------------- */
GTI_BYTE
Gti_GetChipVersion(GTI_XCVR_INFO *pSys)
{
#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)
    GTI_WORD wResult;
#endif
#if defined( GTI_DSPVIKING)
    GTI_DWORD dwResult;
#endif
    GTI_BYTE bReturn = 0;

#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)

    CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);
    WRITE_DSP_ADDR(pSys, GTI_DSP_A, 0x85, GTI_IREGA|GTI_READ_DSP);
    wResult = READ_DSP_WORD(pSys, GTI_DSP_A);

#if defined(GTI_DSPQUAD)
    bReturn = (GTI_BYTE)((wResult >> 1) & 0x03);
#else
    bReturn = (GTI_BYTE)((wResult >> 11) & 0x03);
#endif
#elif defined(GTI_DSPVIKING)
    /* Viking - can be viking, turbo, monaco, groucho */
    #if defined(GTI_DSPTURBO)
    CONFIGURE_DSP(pSys, GTI_DSP_TOP, GTI_NO_AI);
    WRITE_DSP_REG(pSys,  0x0c, 0x3d );  /* Low Address SAP for Top */
    WRITE_DSP_REG(pSys,  0x0d, ((GTI_VREG0-GTI_VREG_ADJUST)|GTI_READ_DSP));
    dwResult =   READ_DSP_REG( pSys, 0x1a );         /* Low byte 0->7  */
    dwResult |= (READ_DSP_REG( pSys, 0x1b ))<<0x08;  /*     byte 8->15 */
    dwResult |= (READ_DSP_WORD( pSys, GTI_DSP_TOP ) <<0x10);

    /* Bits 31->24(8)    = Reserved */
    /* Bits 23->16(8)    = Version  */
    /* Bits 15->0 (16)   = Product ID */
    
    /* Check Product ID = 0x7777 */
    if( (dwResult&0x0000ffff) == 0x00007777 )
    {
        bReturn = (GTI_BYTE)((dwResult >> 16) & 0x0f);
        bReturn |= 0x40; /* Turbo */
    }
    else
    {
        /* Product ID not correct */
        bReturn = 0xff;
    }
    #elif defined(GTI_DSPMONACO)
    CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_NO_AI);
    WRITE_DSP_ADDR(pSys, GTI_DSP_TOP, 0x3d, ((GTI_VREG0-GTI_VREG_ADJUST)|GTI_READ_DSP));
    dwResult =   READ_DSP_REG( pSys, 0x1a );         /* Low byte 0->7  */
    dwResult |= (READ_DSP_REG( pSys, 0x1b ))<<0x08;  /*     byte 8->15 */
    dwResult |= (READ_DSP_WORD( pSys, GTI_DSP_TOP ) <<0x10);

    /* Bits 31->24(8) = Reserved */
    /* Bits 23->8(16) = Product Id  */
    /* Bits 7->0 (8) =  Version */
    /* Check Product ID = 0x7777 */
    if( (dwResult&0x00ffff00) == 0x00707400 )
    {
        bReturn = (GTI_BYTE)((dwResult) & 0x0f);
        bReturn |= 0x20; /* Monaco */
    }
    else
    {
        /* Product ID not correct */
        bReturn = 0xff;
    }
    #else /* Viking Only */

    dwResult = Gti_ReadVikingRegister( pSys, 0x0837 );
    switch( dwResult )
    {

       case 0x00810011:
       case 0x00810012:
            bReturn = GTI_DSP_VIKING_VER_1_X;
            break;
       case 0x00810020:
            bReturn = GTI_DSP_VIKING_VER_B_X;
            break;
       default:
            /* Product ID not correct */
            bReturn = 0;
            break;

    }
    #endif /* !Turbo, !Monaco */
#else
    bReturn = (GTI_BYTE)(READ_DSP_BYTE(pSys, GTI_DSP_A, GTI_MASKTEST_DSP) & 0x03);
#endif

    return bReturn;
}

/******************************************************************************/
/* Procedure: Gti_GetLineDataStatus                                           */
/* --------------------------------                                           */
/* Description: The function Returns the Line Data Status in a structure      */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_GetLineDataStatus(GTI_XCVR_INFO *pSys,
                      GTI_LINE_DATA_STATUS_TYPE *pLS,
                      GTI_WORD nLength)
{

#define _GET_FAILURE(a) (MAKEWORD(arrFail[((a)-GTI_local_LOS_failure_LOC)*2], \
        arrFail[((a)-GTI_local_LOS_failure_LOC)*2+1]))

#define _GET_LINE_DB(a) (MAKEWORD((arrLdBl[(a)-GTI_LINE_DATA_BLOCK_START]), \
        (arrLdBl[(a)-GTI_LINE_DATA_BLOCK_START + 1])))

#define _GET_ACTC_DB(a) (MAKEWORD((arrConf[(a)-GTI_ACTUAL_CONFIG_START]),   \
        (arrConf[(a)-GTI_ACTUAL_CONFIG_START + 1])))

    GTI_BYTE bData;
    GTI_WORD wData1, wData2;

    GTI_BYTE arrFail[(GTI_remote_LCDF_failure_LOC - GTI_local_LOS_failure_LOC + 1)*2];
    GTI_BYTE arrLdBl[GTI_LINE_DATA_BLOCK_END - GTI_LINE_DATA_BLOCK_START + 2];
    GTI_BYTE arrConf[GTI_ACTUAL_CONFIG_END - GTI_ACTUAL_CONFIG_START + 2];

    if((nLength < GTI_LINE_DATA_STATUS_LEN) || (Gti_IsCXfrActive(pSys)))
        return 0;

    GET_HOST_DB_BLOCK(pSys, GTI_ACTUAL_CONFIG_START,
        (GTI_WORD)sizeof(arrConf), arrConf);

    GET_HOST_DB_BLOCK(pSys, GTI_LINE_DATA_BLOCK_START,
        (GTI_WORD)sizeof(arrLdBl), arrLdBl);

    pLS->adslAtucInvVendorID = GTI_ID_GLOBESPAN;
    pLS->adslAtucInvVersionNumber = GTI_VENDOR_REV_SHORT_ITEM;
    pLS->adslAtucCurrStatus = 0; /* No Defect */
    pLS->adslAturCurrStatus = 0; /* No Defect */

    (void)Gti_GetMarginPerBinStatus(pSys, GTI_SNR_MARGIN_PER_BIN, 0, nLength, (char *)&bData);
    pLS->adslCurrSnrMgn = bData;

    if(GET_HOST_DB_B(pSys, GTI_MODE) == GTI_CO)
    {
        wData1 = _GET_LINE_DB(GTI_CO_ATTN);
        pLS->adslAtucCurrAtn = wData1 >> 3;
    }
    else
    {
        pLS->adslAtucCurrAtn = GET_HOST_DB_B(pSys, GTI_R_MSG2 + 3) >> 1;
    }

    pLS->adslAtucTxPowerAttenuation =_GET_LINE_DB(GTI_SEL_TX_POWER_ATTENUATION);

    if(GET_HOST_DB_B(pSys, GTI_MODE) == GTI_CO)
        pLS->adslAturCurrAtn = GET_HOST_DB_B(pSys, GTI_R_MSG2 + 3) >> 1;
    else
        pLS->adslAturCurrAtn = GET_HOST_DB_B(pSys, GTI_C_MSG2 + 3) >> 2;

     /* FDP is 20 bits so shift down by 4 to align lsb */
    wData1 = _GET_LINE_DB(GTI_NO_TX_BINS);
    pLS->adslAtucNoTxBins = wData1 >> 4;

    CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_AI);
    WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_local_LOS_failure_LOC, GTI_ISRAM|GTI_READ_DSP);
    READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_DATAL_DSP, (GTI_WORD)(sizeof(arrFail)), arrFail);

    /* clear failure counters -- Assumes Annex A only */
    WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_failure_overall_LOC, GTI_ISRAM );
    WRITE_DSP_WORD(pSys, GTI_DSP_A , 0x00, 0x00);


    if((_GET_FAILURE(GTI_local_LCDI_failure_LOC) > 0x7f) ||
       (_GET_FAILURE(GTI_local_LCDF_failure_LOC) > 0x7f))
        pLS->adslAtucCurrStatus |= 0x2;

    if(_GET_FAILURE(GTI_local_LOS_failure_LOC) > 0x7f)
        pLS->adslAtucCurrStatus |= 0x4;

    if((_GET_FAILURE(GTI_local_NCDI_failure_LOC) > 0x7f) ||
       (_GET_FAILURE(GTI_local_NCDF_failure_LOC) > 0x7f))
        pLS->adslAtucCurrStatus |= 0x10;

    if((_GET_FAILURE(GTI_remote_LCDI_failure_LOC) > 0x7f) ||
       (_GET_FAILURE(GTI_remote_LCDF_failure_LOC) > 0x7f))
        pLS->adslAturCurrStatus |= 0x2;

    if(_GET_FAILURE(GTI_remote_LOS_failure_LOC) > 0x7f)
        pLS->adslAturCurrStatus |= 0x4;

    if((_GET_FAILURE(GTI_remote_LOS_failure_LOC) != 0) ||
       (_GET_FAILURE(GTI_remote_POW_failure_LOC) != 0))
        pLS->adslAturCurrStatus |= 0x8;

    /* FDP is 20 bits so shift down by 4 to align lsb */
    wData1 = _GET_LINE_DB(GTI_NO_RX_BINS);
    pLS->adslAturCurrOutputPwr = wData1 >> 4;

    /* S RS DOWN */
    wData1 = _GET_ACTC_DB(GTI_ACTUAL_DWN_RRSD + 2) & 0x3f;

    /* D RS DOWN  10 bits*/
    wData2 = _GET_ACTC_DB(GTI_ACTUAL_DWN_RRSD + 3) |
        ((_GET_ACTC_DB(GTI_ACTUAL_DWN_RRSD + 2) & 0x00c0) << 0x02);

    pLS->adslAtucChanInterleaveDelay = (GTI_WORD)(wData1 * wData2/4);

    /* adslAtucChanCurrAS0TxRate */
    /* As0 Bytes down - */
    if(_GET_ACTC_DB(GTI_ACTUAL_DWN_RATES1_BF) != 0)
    {
        wData1 = _GET_ACTC_DB(GTI_ACTUAL_DWN_RATES1_BF);
    }
    else
    {
        /* Need to get high Bit of AS0 speed */
        wData1 = (_GET_ACTC_DB(GTI_ACTUAL_DWN_RATES1_BI) & 0xff) |
            ((((_GET_ACTC_DB(GTI_ACTUAL_DWN_RRSD+1) & 0xff)) << 0x1) & 0x0100);
    }

    pLS->adslAtucChanCurrAs0TxRate = (GTI_WORD)(wData1 * 32);
    pLS->adslAtucCrcBlockLength = (GTI_WORD)(wData1 * 68);

    /* S RS UP */
    wData1 = _GET_ACTC_DB(GTI_ACTUAL_UP_RRSD + 7) & 0x3f;

    /* D RS UP 10 bits*/
    wData2 = (_GET_ACTC_DB(GTI_ACTUAL_UP_RRSD + 8) |
        ((_GET_ACTC_DB(GTI_ACTUAL_UP_RRSD + 7) & 0x00c0) << 0x02));

    pLS->adslAturChanInterleaveDelay = (GTI_WORD)(wData1 * wData2/4);

    /* Ls0 Bytes up */
    if(_GET_ACTC_DB(GTI_ACTUAL_UP_RATES1_BF + 7) != 0)
        wData1 = _GET_ACTC_DB(GTI_ACTUAL_UP_RATES1_BF + 7);
    else
        wData1 = _GET_ACTC_DB(GTI_ACTUAL_UP_RATES1_BI + 7);
    pLS->adslAturChanCurrLs0TxRate = (GTI_WORD)(wData1 * 32);

    /* adslAturCrcBlockLength */
    pLS->adslAturCrcBlockLength = (GTI_WORD)(wData1 * 68);

    return GTI_LINE_DATA_STATUS_LEN;
}

#ifdef GTI_ESC
/******************************************************************************/
/* Procedure: Gti_GetPMDataStatus                                             */
/* --------------------------------                                           */
/* Description: The function Returns the PM Data Status in a structure        */
/* -------------------------------------------------------------------------- */
GTI_WORD
Gti_GetPMDataStatus(GTI_XCVR_INFO *pSys,
                    GTI_PM_DATA_STATUS_TYPE *pPM,
                    GTI_WORD nLength)
{

#define _GET_COUNTER(a) (MAKEWORD(arrCntr[((a)-GTI_local_RSI_counter_LOC)*2], \
    arrCntr[((a)-GTI_local_RSI_counter_LOC)*2+1]))

#define _GET_COUNTE2(a) (MAKEWORD(arrCnt2[((a)-GTI_local_ESL_counter_LOC)*2], \
    arrCnt2[((a)-GTI_local_ESL_counter_LOC)*2+1]))

#define _UPDATE_COUNTER(x,y) pPM->x = (GTI_WORD)((GTI_WORD)y - (GTI_WORD)pSys->PM.x); \
    pSys->PM.x = y

    GTI_WORD wSuperFrame;
    GTI_BYTE arrCntr[(GTI_remote_HECF_counter_LOC - GTI_local_RSI_counter_LOC + 1) * 2];
    GTI_BYTE arrCnt2[(GTI_remote_UAS_counter_LOC - GTI_local_ESL_counter_LOC + 1) * 2];

    if((nLength < GTI_PM_DATA_STATUS_LEN) || (Gti_IsCXfrActive(pSys)))
        return 0;

    CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_AI);
    WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_local_RSI_counter_LOC, GTI_ISRAM|GTI_READ_DSP);
    READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_DATAL_DSP, (GTI_WORD)(sizeof(arrCntr)), arrCntr);

    WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_local_ESL_counter_LOC, GTI_ISRAM|GTI_READ_DSP);
    READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_DATAL_DSP, (GTI_WORD)(sizeof(arrCnt2)), arrCnt2);

    WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_superCounter_LOC, GTI_ISRAM|GTI_READ_DSP);
    wSuperFrame = READ_DSP_WORD(pSys, GTI_DSP_A);

    _UPDATE_COUNTER(adslAtucChanReceivedBlks,wSuperFrame);
    _UPDATE_COUNTER(adslAtucChanTransmittedBlks,wSuperFrame);

    /*
       Parse each counter out of the memory block.  Then subtract it from previous
       values to get current value.   Then store it for future comparisons.
     */
    _UPDATE_COUNTER(adslAtucChanCorrectedBlksI,_GET_COUNTER(GTI_local_RSI_counter_LOC));
    _UPDATE_COUNTER(adslAtucChanCorrectedBlksF,_GET_COUNTER(GTI_local_RSF_counter_LOC));
    _UPDATE_COUNTER(adslAtucChanUncorrectBlksI,_GET_COUNTER(GTI_local_CRCI_counter_LOC));
    _UPDATE_COUNTER(adslAtucChanUncorrectBlksF,_GET_COUNTER(GTI_local_CRCF_counter_LOC));

    _UPDATE_COUNTER(adslAturChanReceivedBlks,wSuperFrame);
    _UPDATE_COUNTER(adslAturChanTransmittedBlks,wSuperFrame);

    _UPDATE_COUNTER(adslAturChanCorrectedBlksI,_GET_COUNTER(GTI_remote_RSI_counter_LOC));
    _UPDATE_COUNTER(adslAturChanCorrectedBlksF,_GET_COUNTER(GTI_remote_RSF_counter_LOC));
    _UPDATE_COUNTER(adslAturChanUncorrectBlksI,_GET_COUNTER(GTI_remote_CRCI_counter_LOC));
    _UPDATE_COUNTER(adslAturChanUncorrectBlksF,_GET_COUNTER(GTI_remote_CRCF_counter_LOC));

    /* The following two are set to zero for now */
    pPM->adslAtucPerfStatFastR = 0;
    pPM->adslAtucPerfStatFailedFastR = 0;

    _UPDATE_COUNTER(adslAtucPerfStatSesL,_GET_COUNTE2(GTI_local_SESL_counter_LOC));
    _UPDATE_COUNTER(adslAtucPerfStatUasL,_GET_COUNTE2(GTI_local_UAS_counter_LOC));
    _UPDATE_COUNTER(adslAturPerfStatSesL,_GET_COUNTE2(GTI_remote_SESL_counter_LOC));
    _UPDATE_COUNTER(adslAturPerfStatUasL,_GET_COUNTE2(GTI_remote_UAS_counter_LOC));
    _UPDATE_COUNTER(adslAtucPerfStatErrS,_GET_COUNTE2(GTI_local_ESL_counter_LOC));
    _UPDATE_COUNTER(adslAturPerfStatErrS,_GET_COUNTE2(GTI_remote_ESL_counter_LOC));

    return GTI_PM_DATA_STATUS_LEN;
}
#endif

/*****************************************************************************/
/* Procedure: Gti_SStatusXCVR                   Created: 09.24.98            */
/* ----------------------                                                    */
/* Description: The function analizes the XCVR system status information and */
/*          returns this information in a caller supplied buffer. The        */
/*          length of the returned information in bytes is returned. If      */
/*          the status is not availiable, on some processing error occurs    */
/*          the returned result is zero.                                     */
/* ------------------------------------------------------------------------- */
GTI_WORD
Gti_SStatusXCVR(GTI_XCVR_INFO *pSys,    /* System Pointer                   */
            GTI_WORD nStatusType,        /* type of required status          */
            void *pStatus,               /* Pointer to the status buffer     */
            GTI_WORD nLength,            /* Maximum length of the buffer     */
            GTI_BYTE nChanID
)
{
    GTI_DWORD *pDWordBuffer;
    GTI_WORD ntmpBuffer[4];
    GTI_BYTE tmp1, tmp2, nDspID,  *pByteBuffer;
    GTI_WORD j, i, nRetSize, *pWordBuffer;

    signed short nSResult[2] = {0, 0};

    nRetSize = 0;
    pWordBuffer = (GTI_WORD *)pStatus;
    pByteBuffer = (GTI_BYTE *)pStatus;

    nDspID = (GTI_BYTE)((nChanID == GTI_CH_A) ? GTI_DSP_A : GTI_DSP_B);
    nDspID = nDspID; /* kill warning if the dsp id is not used */

    pDWordBuffer = (GTI_DWORD *)pStatus;

#ifdef GTI_HOST_SASSTATUS
    /* Only do "C" status if status is not supported by binary */
    if( nStatusType <  GTI_MAX_STATUS_TABLE_SIZE )
    {
           nRetSize= Gti_GetBinaryStatus(pSys,  nStatusType, pWordBuffer, nLength);
    }

    if( nRetSize != 0 )
    {
           return(nRetSize);
    }
#endif /*Host SAS status */


    switch(nStatusType)
    {
    case GTI_FW_REL:
    /**************/
        if(nLength >= GTI_FW_REL_LEN)
        {
            nRetSize = GTI_FW_REL_LEN;
#ifdef GTI_BUILD_DSP_SEPERATE
            /* Get FW Release from Binary */
            i =Gti_InitPointers(&(pSys->StatusInfo), GTI_PRIMARY_PROJECT_ID(pSys));
            if( i == GTI_OK )
            {
               memcpy(pStatus, (pSys->StatusInfo.ProjectPointer+GTI_PROJECT_VERSION_OFFSET), GTI_FW_REL_LEN);
            }
            else
            {
               nRetSize = 0x00;
            }
#else 
#if ( (defined(GTI_DSPVIKING) && (defined(GTI_HOSTVSC))) )
            memcpy(pStatus, pGtiFwRel, GTI_FW_REL_LEN);
#else
            memcpy(pStatus, RELEASE, GTI_FW_REL_LEN);
#endif
#endif /* !Host Binary */
        }
        break;

#ifdef GTI_HOST_SASSTATUS
    case GTI_TSM_REL:
    /**************/
        if(nLength >= GTI_TSM_REL_LEN)
        {
            memcpy(pStatus, HOSTRELEASE, GTI_TSM_REL_LEN);
            nRetSize = GTI_TSM_REL_LEN;
        }
        break;
    case GTI_STATUS_RESULT:
    /**************/
        if(nLength >= GTI_STATUS_RESULT_LEN)
        {
            pWordBuffer[0] = pSys->CmdInfo.state;
            nRetSize = GTI_STATUS_RESULT_LEN;
        }

        break;
#endif /* SAS status mode */

    case GTI_LAST_FAILED_STATUS:
    /**************************/
        if(nLength >= GTI_LAST_FAILED_STATUS_LEN)
        {
            pWordBuffer[0] = GET_HOST_DB_W(pSys, GTI_LAST_FAILED_LOCATION);
            nRetSize = GTI_LAST_FAILED_STATUS_LEN;
        }
        break;

    case GTI_MEAN_SQ_ERROR:
    /*********************/
    case GTI_MEAN_SQ_NEXT_ERROR:   /* Annex C only */
    /**************************/
        nRetSize = Gti_GetMeanSQStatus(pSys, nStatusType, pWordBuffer, nLength);
        break;

    case GTI_OP_STATE:
    /****************/
        if(nLength >= GTI_OP_STATE_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_OP_CH_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_OP_STATE_LEN;
        }
        break;

    case GTI_RECEIVER_GAIN:
    /*********************/
        if(nLength >= GTI_RECEIVER_GAIN_LEN)
        {
            if( !Gti_IsCXfrActive(pSys) )
            {
                /* Check Which Annex */
                if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
                {
                    CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
                    WRITE_DSP_ADDR(pSys, nDspID, GTI_ragc_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                    pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_totalPGAgain_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[0] = (signed short)READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_analogRxMode_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[1] = (signed short)READ_DSP_WORD(pSys, nDspID);
                }
                else
                {
                    CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
                    WRITE_DSP_ADDR(pSys, nDspID, GTI_ragc_LOC, GTI_ISRAM|GTI_READ_DSP);
                    pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_totalPGAgain_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[0] = (signed short)READ_DSP_WORD(pSys, nDspID);

                    WRITE_DSP_ADDR(pSys, nDspID, GTI_analogRxMode_LOC, GTI_ISRAM|GTI_READ_DSP);
                    nSResult[1] = (signed short)READ_DSP_WORD(pSys, nDspID);
                }

                if(nSResult[1] == 1)
                    nSResult[1] = 0;
                else
                    nSResult[1] = (short)((Gti_GetCurrentMode(pSys) == GTI_CO) ? 260 : 370);

                pWordBuffer[1] = (GTI_WORD)(nSResult[0] - nSResult[1]);

                nRetSize = GTI_RECEIVER_GAIN_LEN;
            }
        }

        break;

    case GTI_DSP_VERSION:
    /***********************/
        if(nLength >= GTI_DSP_VERSION_LEN)
        {
            pByteBuffer[0] = Gti_GetChipVersion(pSys);
            nRetSize = GTI_DSP_VERSION_LEN;
        }
        break;

    case GTI_AFE_VERSION:
    /***********************/
        if(nLength >= GTI_AFE_VERSION_LEN)
        {
            pByteBuffer[0] = pSys->pChipInfo->bAfeVersion;
            nRetSize = GTI_AFE_VERSION_LEN;
        }
        break;

#ifdef GTI_DSPQUAD             /* Trinity/Fourte */

    case GTI_LBUS_FW_VERSION:
    /***********************/
        if(nLength >= GTI_FW_REL_LEN)
        {
            memcpy(pStatus, pSys->pChipInfo->lBusVersion,
                sizeof(pSys->pChipInfo->lBusVersion));
            nRetSize = sizeof(pSys->pChipInfo->lBusVersion);
        }
        break;

#endif /* GTI_DSPQUAD */

    case GTI_RESERVED_0_STATUS:
        if(nLength >= GTI_RESERVED_0_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x34, GTI_IREGA|GTI_READ_DSP);
            pWordBuffer[0] = (GTI_WORD)(READ_DSP_WORD(pSys, nDspID) & 0x4500);
            nRetSize = GTI_RESERVED_0_STATUS_LEN;
        }
        break;

    case GTI_RESERVED_1_STATUS:
        if(nLength >= GTI_RESERVED_1_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x12, GTI_IREGA|GTI_READ_DSP);
            pWordBuffer[0] = (GTI_WORD)(READ_DSP_WORD(pSys, nDspID) & 0x3333);
            nRetSize = GTI_RESERVED_1_STATUS_LEN;
        }
        break;

    case GTI_XMIT_POWER:
    /******************/
        if(nLength >= GTI_XMIT_POWER_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_XMIT_LOCATION, GTI_ISRAM|GTI_READ_DSP);
            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_XMIT_POWER_LEN;
        }
        break;

    case GTI_START_PROGRESS:
    /**********************/
        if(nLength >= GTI_START_PROGRESS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_PROGRESS_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_START_PROGRESS_LEN;
        }
        break;

     case GTI_WATCHDOG_TIMER:
    /**********************/
        if(nLength >= GTI_WATCHDOG_TIMER_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_WATCHDOG_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
            nRetSize = GTI_WATCHDOG_TIMER_LEN;

                /* Clear WatchDog Timer */
            WRITE_DSP_ADDR(pSys, nDspID, GTI_WATCHDOG_LOCATION, GTI_ISRAM);
            WRITE_DSP_WORD(pSys, nDspID, 0x00,0x00);
        }
        break;

    case GTI_BERT_ERROR:
    /******************/
        if(nLength >= GTI_BERT_ERROR_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_OP_CH_LOCATION, GTI_ISRAM|GTI_READ_DSP);

            if ( READ_DSP_WORD(pSys, nDspID) == GTI_DATA_OP )
            {
                WRITE_DSP_ADDR(pSys, nDspID, 0x9b,(GTI_BYTE)(GTI_PSRAM0W|GTI_READ_DSP) );
                pWordBuffer[1] = (GTI_WORD)(( READ_DSP_WORD(pSys,nDspID) & 0x01 ) << 0x07 );

                WRITE_DSP_ADDR(pSys, nDspID, 0xbc, (GTI_BYTE)(GTI_PSRAM0W|GTI_READ_DSP) );
                pWordBuffer[0] = READ_DSP_WORD(pSys,nDspID);

                WRITE_DSP_ADDR(pSys, nDspID, 0xbc, GTI_PSRAM0W);
                WRITE_DSP_WORD(pSys, nDspID, 0x00,0x00);
            }
            else
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_BERT_SYNC_LOCATION, (GTI_BYTE)(GTI_IREGA|GTI_READ_DSP) );

                pWordBuffer[1] = (GTI_WORD)((READ_DSP_WORD(pSys, nDspID) >> 0x08) & 0x0080);

                WRITE_DSP_ADDR(pSys, nDspID, GTI_BERT_ERROR_LOCATION, (GTI_BYTE)(GTI_IREGA|GTI_READ_DSP) );

                pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
                if ( pWordBuffer[0] & 0x8000 )
                    pWordBuffer[0] = 0x7fff ;
            }

            nRetSize = GTI_BERT_ERROR_LEN;

        }
        break;

    case GTI_UPSTREAM_MARGIN_STATUS:
    /************************************/
        if(nLength >= GTI_UPSTREAM_MARGIN_STATUS_LEN)
        {
            pByteBuffer[0] = (GTI_BYTE) (( GET_HOST_DB_B( pSys, GTI_C_MSG2 +2 )) & 0x1f);
            nRetSize =  GTI_UPSTREAM_MARGIN_STATUS_LEN;
        }
        break;

    case GTI_LCL_XMIT_POWER_STATUS:
    /******************/
        if(nLength >= GTI_LCL_XMIT_POWER_STATUS_LEN)
        {
            pWordBuffer[0] = GET_HOST_DB_W(pSys, GTI_SEL_TX_POWER_ATTENUATION);

            /* FDP is 20 bits so shift down by 4 to align lsb */
            pWordBuffer[1] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_NO_TX_BINS) >> 0x04) |
                (GET_HOST_DB_B(pSys, GTI_NO_TX_BINS+1) << 0x04));

            nRetSize = GTI_LCL_XMIT_POWER_STATUS_LEN;
        }
        break;

    case GTI_RMT_TX_POWER_STATUS:
    /******************/
        if(nLength < GTI_RMT_TX_POWER_STATUS_LEN)
            return 0;

#if ( !(defined(GTI_DSPVIKING) && (defined(GTI_HOSTVSC))) )
        /* FDP is 20 bits so shift down by 4 to align lsb */
        pWordBuffer[0] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_NO_RX_BINS) >> 0x04) |
            (GET_HOST_DB_B(pSys, GTI_NO_RX_BINS+1) << 0x04));
        nRetSize = GTI_RMT_TX_POWER_STATUS_LEN;
#else
        /*
        ** The 6|7|8 bits of GTI_C_MSG1 contains the index corresponding 
        ** to PSD value.  
        */
        i = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_C_MSG1 + 1) & 0x01);
        j = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_C_MSG1) & 0xc0);
        
        pWordBuffer[0] = (GTI_WORD)(((i << 8) | j) >> 6);
        
        /*
        ** The attenuations is difference of the PSD values corresponding to
        ** PSDs at attenuation 0 and PSD at attenuation 7. Look for GTI_C_MSG1
        ** message in the adsl design guide.
        */      
        if(pWordBuffer[0] <= 7)
        {
            pWordBuffer[0] = (7 - pWordBuffer[0]) * 2 ;
        }
        else
        {
            pWordBuffer[0] = 0 ;
        }

        /*
        ** FDP is 20 bits so shift down by 4 to align lsb
        */
        pWordBuffer[1] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_NO_RX_BINS) >> 0x04) |
            (GET_HOST_DB_B(pSys, GTI_NO_RX_BINS+1) << 0x04));

        nRetSize = GTI_RMT_TX_POWER_STATUS_LEN + 2; 
#endif /* Viking and HostVSC */

        break;

    case GTI_RMT_VENDOR_ID_STATUS:
    /*****************************/

        /* Length is dependent on standard type */
        tmp1 = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD));
        i = GTI_RMT_VENDOR_ID_STATUS_LEN;

        if( (tmp1 == GTI_G_LITE_STANDARD))
            i = GTI_RMT_VENDOR_ID_G_LITE_STATUS_LEN;
        else if( (tmp1 == GTI_G_DMT_STANDARD) )
            i = GTI_RMT_VENDOR_ID_G_DMT_STATUS_LEN;
        else if( (tmp1 == GTI_CENT_LITE_STANDARD))
            i = GTI_RMT_VENDOR_ID_G_LITE_STATUS_LEN;
        else if( (tmp1 == GTI_RESERVE_STANDARD))
            i = GTI_RMT_VENDOR_ID_G_LITE_STATUS_LEN;
        else if( (tmp1 == GTI_CENT_FULL_RATE) )
            i = GTI_RMT_VENDOR_ID_G_DMT_STATUS_LEN;
        else
            i = GTI_RMT_VENDOR_ID_STATUS_LEN;

        if(nLength >= i)
        {
            /* Location is dependent on standard type */
            if( (tmp1 == GTI_G_LITE_STANDARD) || (tmp1 == GTI_G_DMT_STANDARD)
              || (tmp1 == GTI_CENT_LITE_STANDARD) || (tmp1 == GTI_RESERVE_STANDARD) 
              || (tmp1 == GTI_CENT_FULL_RATE) )

            {
                pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+1) << 0x08) );
                pWordBuffer[1] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk+2) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+3) << 0x08) );
                pWordBuffer[2] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk+4) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+5) << 0x08) );
            }
            else
            {
                pWordBuffer[0] = (GTI_WORD)(((GET_HOST_DB_B(pSys, GTI_RMT_MSG_2+1) >> 0x04) & 0x0f) |
                    ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_3) << 0x04) & 0x0ff0) |
                    ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_3+1) << 12) & 0xf000));
            }

            nRetSize = i;
        }
        break;

    case GTI_RMT_VENDOR_REV_STATUS:
    /*****************************/
        if(nLength >= GTI_RMT_VENDOR_REV_STATUS_LEN)
        {
            /* Location of information is dependent on standard type */
            i = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD));
            if((i == GTI_G_LITE_STANDARD) || (i == GTI_G_DMT_STANDARD)
	     ||  (i == GTI_CENT_LITE_STANDARD) ||  (i == GTI_RESERVE_STANDARD)
	     || (i == GTI_CENT_FULL_RATE) )
            {
                pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_vndIDBlk+6) |
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+7) << 0x08) );
            }
            else
            {
                pWordBuffer[0] = (GTI_WORD) ((GET_HOST_DB_B(pSys, GTI_RMT_MSG_2) >> 2) & 0x1f);
            }

            nRetSize = GTI_RMT_VENDOR_REV_STATUS_LEN;
        }
        break;

#ifndef GTI_PAGE_E_BUILT
    case GTI_RS_FRAME_COUNTER:
    /*****************************/
        if((nLength >= GTI_RS_FRAME_COUNTER_LEN) && (!Gti_IsCXfrActive(pSys)))
        {
            /* Counter for RS Frames */
            /* IPU counter * 68/PCU# */
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);

            /* Check Which Annex */
            if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_C_LOC, GTI_ISRAM|GTI_READ_DSP);
            }
            else
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_LOC, GTI_ISRAM|GTI_READ_DSP);
            }
            i = READ_DSP_WORD(pSys, nDspID);
            i *= 68;

            if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_C_LOC, GTI_ISRAM );
            }
            else
            {
                WRITE_DSP_ADDR(pSys, nDspID, GTI_superCounter_LOC, GTI_ISRAM );
            }

            WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x00);

            tmp1 = (GTI_BYTE) ((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD+2))&0x3f);
            tmp2 = (GTI_BYTE) ((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD+7))&0x3f);

            if( tmp1 == 0 ) tmp1 = 1;
            if( tmp2 == 0 ) tmp2 = 1;

            /* Word 0 - Down RS Frame Count */
            pWordBuffer[0] = (GTI_WORD) (i/tmp1);

            /* Word 1 - Up RS Frame Count */
            pWordBuffer[1] = (GTI_WORD) (i/tmp2);

            nRetSize = GTI_RS_FRAME_COUNTER_LEN;
        }
        break;
#endif /* !Page E built */

    case GTI_ATM_CELL_COUNTER:
    /*************************/
        if(nLength >= GTI_ATM_CELL_COUNTER_LEN)
        {
            /* Counter for ATM cells  */

            /* RX cell counter */
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0xbb, GTI_PSRAM0W|GTI_READ_DSP);

            ntmpBuffer[0] = READ_DSP_WORD(pSys, nDspID);

            /* TX cell counter */
            WRITE_DSP_ADDR(pSys, nDspID, 0xfb, GTI_PSRAM0W|GTI_READ_DSP);

            ntmpBuffer[1] = READ_DSP_WORD(pSys, nDspID);

            /* Subtract previous from current */
            /* Current = ntmpbuffer           */
            /* Previous = hostram DB          */

            j = GET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_RX_CELL_CNT);
            pWordBuffer[0] = (GTI_WORD)(ntmpBuffer[0] - j);

            j = GET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_TX_CELL_CNT);
            pWordBuffer[1] = (GTI_WORD)(ntmpBuffer[1] - j);

            /* Save current value */
            SET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_RX_CELL_CNT, ntmpBuffer[0] );
            SET_HOST_DB_W(pSys, GTI_PREVIOUS_ATM_TX_CELL_CNT, ntmpBuffer[1] );

            nRetSize = GTI_ATM_CELL_COUNTER_LEN;
        }
        break;

    case GTI_IDLE_BERT_STATUS:
    /************************/
        if(nLength >= GTI_IDLE_BERT_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0xbc, (GTI_PSRAM0W|GTI_READ_DSP) );

            /* BERT_ERRORS */
            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);

            /* BERT Cells */
            pWordBuffer[1] = READ_DSP_WORD(pSys, nDspID);

            /* clear both counters */
            WRITE_DSP_ADDR(pSys, nDspID, 0xbc, GTI_PSRAM0W);
            WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x00);
            WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x00);

            nRetSize = GTI_IDLE_BERT_STATUS_LEN;
        }
        break;

    case GTI_FAST_RETRAIN_STATUS:
    /***************************/
#if defined(GTI_DIS_FR)
        if((nLength >= GTI_FAST_RETRAIN_STATUS_LEN) && (!Gti_IsCXfrActive(pSys)))
        {
            pWordBuffer[0] = 0;
            pWordBuffer[1] = 0;
            pWordBuffer[2] = 0;
            nRetSize = GTI_FAST_RETRAIN_STATUS_LEN;
        }
        break;
#else
        if((nLength >= GTI_FAST_RETRAIN_STATUS_LEN) && (!Gti_IsCXfrActive(pSys)))
        {
            pWordBuffer[0] = GET_HOST_DB_W(pSys, GTI_FRSTATUS);
            pWordBuffer[1] = GET_HOST_DB_W(pSys, GTI_TX_PROFILE);
            pWordBuffer[2] = GET_HOST_DB_W(pSys, GTI_RX_PROFILE);

            /* clear status */
            i = GTI_FRSTATUS;
            j = GTI_FAST_RETRAIN_NO_ACTIVITY;
            SET_HOST_DB_W(pSys, i, j);

            nRetSize = GTI_FAST_RETRAIN_STATUS_LEN;
        }
        break;
#endif

    case GTI_LCL_SNR_MARGIN:
    /**********************/
        if((nLength >= GTI_LCL_SNR_MARGIN_LEN) && (!Gti_IsCXfrActive(pSys)))
            nRetSize = Gti_GetMarginPerBinStatus(pSys, nStatusType, 0, nLength, (char *)&pByteBuffer[0]);
        break;

    case GTI_LCL_ANNEX_C_MODE:
    /************************/
        if(nLength >= GTI_LCL_ANNEX_C_MODE_LEN)
        {
            pByteBuffer[0] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_ANNEX_C_MODE));
            nRetSize = GTI_LCL_ANNEX_C_MODE_LEN;
        }
        break;

    case GTI_OVERLAP_STATUS:
    /**********************/
        if(Gti_GetCurrentMode(pSys) == GTI_CO)
        {
            pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_TX_START_BIN));
        }
        else
        {
            if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
            {
                pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_RX_START_BIN + 2));
            }
            else
            {
                /* FDP is 20 bits so shift down by 4 to align lsb */
                pWordBuffer[0] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_RX_START_BIN) >> 0x04) |
                    (GET_HOST_DB_B(pSys, GTI_RX_START_BIN + 1) << 0x04));
            }
        }

        if(pWordBuffer[0] < 0x20)
            pByteBuffer[0] = 0x1; /* overlap mode */
        else
            pByteBuffer[0] = 0x0; /* non overlap mode */

        nRetSize = GTI_OVERLAP_STATUS_LEN;
        break;

    case GTI_LCL_FW_REV_NUM:
    /**********************/
        if(nLength >= GTI_LCL_FW_REV_NUM_LEN)
        {
            pByteBuffer[0] = GTI_LCL_FW_REV_NUM_VALUE ;
            nRetSize = GTI_LCL_FW_REV_NUM_LEN ;
        }
        break;

    case GTI_LCL_CODING_GAIN:
    /***********************/
        if(nLength >= GTI_LCL_CODING_GAIN_LEN)
        {
            pByteBuffer[0] = (GTI_BYTE)((GET_HOST_DB_B(pSys, GTI_ACT_CODING_GAIN2) & 0xff) / 2);
            nRetSize = GTI_LCL_CODING_GAIN_LEN;
        }
        break;

    case GTI_BIT_LOADING_UP:
    /**********************/
    case GTI_BIT_LOADING_DN:
    /**********************/
    case GTI_BIT_LOADING_NEXT_UP:
        /***************************/
    case GTI_BIT_LOADING_NEXT_DN:
    /***************************/
        nRetSize = GetBitsPerBinStatus(pSys, nStatusType, (GTI_BYTE *)pStatus, nLength);
        break;

    case GTI_SNR_MARGIN_PER_BIN:
    /**************************/
    case GTI_SNR_MARGIN_PER_BIN_NEXT:
    /*******************************/
        /* If TSM state machine is active then return 0 */
        if( !Gti_IsCXfrActive(pSys) )
            nRetSize = Gti_GetMarginPerBinStatus(pSys, nStatusType, (GTI_WORD *)pStatus, nLength, 0);
        break;

    case GTI_RX_BYTES_STATUS:
    /***********************/
        if(nLength >= GTI_RX_BYTES_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x3, (GTI_PSRAM0W|GTI_READ_DSP) );

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAL_DSP);
            else
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAH_DSP);

            nRetSize = GTI_RX_BYTES_STATUS_LEN;
        }
        break;

    case GTI_TX_BYTES_STATUS:
    /***********************/
        if(nLength >= GTI_TX_BYTES_STATUS_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, 0x2, (GTI_PSRAM0W|GTI_READ_DSP));

            if(Gti_GetCurrentMode(pSys) == GTI_CO)
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAH_DSP);
            else
                pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAL_DSP);

            nRetSize = GTI_TX_BYTES_STATUS_LEN;
        }
        break;

    case GTI_COUNTERS:
    /*****************/
         if(nLength >= GTI_COUNTERS_LEN)
         {
             /* If TSM state machine is active then return 0 */
             if( !Gti_IsCXfrActive(pSys) )
             {
                 CONFIGURE_DSP(pSys, nDspID, GTI_READ_BLOCK_MODE);

                 /* Check Which Annex */
                 if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_local_RSI_counter_C_LOC, GTI_ISRAM|GTI_READ_DSP);
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_local_RSI_counter_LOC, GTI_ISRAM|GTI_READ_DSP);
                 }

                 nRetSize = GTI_COUNTERS_LEN;

                 READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_DATAL_DSP, GTI_COUNTERS_LEN, pByteBuffer);

                 for(i=0; i < (GTI_COUNTERS_LEN / sizeof(GTI_WORD)); i++)
                 {
                    #ifdef GTI_LITTLE_ENDIAN
                        j = MAKEWORD(pByteBuffer[i * 2], pByteBuffer[(i * 2) + 1]);
                    #elif (defined (GTI_BIG_ENDIAN))
                        j = MAKEWORD(pByteBuffer[(i * 2) + 1], pByteBuffer[i * 2]);
                    #elif
                        NO_ENDIAN_MODE_DEFINED
                    #endif
                     pWordBuffer[i] = j;
                 }

                 /* Set Flag to Clear Counter */
                 if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_clrCounters_C_LOC, GTI_ISRAM );
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_clrCounters_LOC, GTI_ISRAM );
                 }

                 WRITE_DSP_WORD(pSys, nDspID, 0x00, 0x80);

                 if(Gti_GetCurrentMode(pSys) == GTI_CO)
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_RSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECI_COUNTER] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_RSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECF_COUNTER] = 0;
                     }
                 }
                 else /* CP */
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_RSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDI_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECI_COUNTER] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_RSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_CRSF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_NCDF_COUNTER] = 0;
                         pWordBuffer[GTI_REMOTE_HECF_COUNTER] = 0;
                     }
                 }
             }
         }
         break;

     case GTI_FAILURES:
         /****************/
         if(nLength >= GTI_FAILURES_LEN)
         {
             /* If TSM state machine is active then return 0 */
             if( !Gti_IsCXfrActive(pSys) )
             {
                 /* Read ISRAM to get local and Remote Counters */
                 /* then set flag to clear counter          */
                 CONFIGURE_DSP(pSys, nDspID, GTI_READ_BLOCK_MODE);

                 /* Check Which Annex */
                 if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_C_LOC, (GTI_ISRAM|GTI_READ_DSP ) );
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_LOC, (GTI_ISRAM|GTI_READ_DSP ) );
                 }

                 READ_DSP_BLOCK(pSys, GTI_DSP_A, GTI_DATAL_DSP, GTI_FAILURES_LEN, pByteBuffer);

                 for(i=0; i < (GTI_FAILURES_LEN / sizeof(GTI_WORD)); i++)
                 {

                    #ifdef GTI_LITTLE_ENDIAN
                        j = MAKEWORD(pByteBuffer[i * 2], pByteBuffer[(i * 2) + 1]);
                    #elif (defined (GTI_BIG_ENDIAN))
                        j = MAKEWORD(pByteBuffer[(i * 2) + 1], pByteBuffer[i * 2]);
                    #elif
                        NO_ENDIAN_MODE_DEFINED
                    #endif

                     pWordBuffer[i] = j;
                 }

                 nRetSize = GTI_FAILURES_LEN;


                 /* Clear Overall Failure Counter directly */
                 /* Check Which Annex */
                 if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_C)
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_C_LOC, GTI_ISRAM );
                 }
                 else
                 {
                     WRITE_DSP_ADDR(pSys, nDspID, GTI_failure_overall_LOC, GTI_ISRAM );
                 }
                 WRITE_DSP_WORD(pSys, nDspID , 0x00, 0x00);

                 if(Gti_GetCurrentMode(pSys) == GTI_CO)
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_NCDI_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDI_FAILURE] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_NCDF_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDF_FAILURE] = 0;
                     }
                 }
                 else /* CP */
                 {
                     if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7) != 0)
                     {
                         pWordBuffer[GTI_REMOTE_NCDI_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDI_FAILURE] = 0;
                     }
                     else
                     {
                         pWordBuffer[GTI_REMOTE_NCDF_FAILURE] = 0;
                         pWordBuffer[GTI_REMOTE_LCDF_FAILURE] = 0;
                     }
                 }

                 for(i=0; i < (GTI_FAILURES_LEN / sizeof(GTI_WORD)); i++)
                 {
                     if(i != GTI_OVERALL_FAILURE)
                     {
                         if(pWordBuffer[i] >= 127)
                             break;
                     }
                 }

                 if(i >= GTI_FAILURES_LEN / sizeof(GTI_WORD))
                     pWordBuffer[GTI_OVERALL_FAILURE] = 0;
             }
         }
         break;

    case GTI_ACTUAL_CONFIGURATION:
        /****************************/
        if(nLength >= GTI_ACTUAL_CONFIGURATION_LEN)
        {
            nRetSize = GTI_ACTUAL_CONFIGURATION_LEN;

            for(i = 0; i < GTI_ACTUAL_CONFIGURATION_LEN/sizeof(GTI_WORD); i++)
                pWordBuffer[i] = 0;

            /* Copy Select Host Ram Locations to Status Buffer */
            /* Fast or Interleaved  is determined by which is != 0*/

            /* Framing OH */
            pWordBuffer[0] = (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_FRAME_STRUCTURE+1) >> 0x01);

            /* Trellis */
            pWordBuffer[1] = (GTI_WORD)(GET_HOST_DB_W(pSys, GTI_ACTUAL_TRELLIS));

            /***************************/
            /* Rates1 Map             */
            /*    HIGH    LOW         */
            /* 0  AS1bytes    AS0bytes*/
            /* 2  AS3bytes    AS2bytes*/
            /* 4  LS1dwn      LS0dwn  */
            /* 6  LS0 up      LS2dwn  */
            /* 8  LS2 up      LS1 up  */
            /***************************/

            /* Fast R RS UP */
            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) != 0) /* As0 Bytes down - */
            {
                pWordBuffer[2] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF);
                if ((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_FRAME_STRUCTURE+1) >> 0x01) ==3 )
                {
                    pWordBuffer[2] = (GTI_WORD)( GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF) |
                        ( (((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD+1) ))<<0x1) & 0x0100) );
                }
                pWordBuffer[3] = GTI_FAST_BUFFER;
            }
            else
            {
                /* Need to get high Bit of AS0 speed */
                pWordBuffer[2] = (GTI_WORD)( GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BI) |
                    ( (((GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD+1) ))<<0x1) & 0x0100) );
                pWordBuffer[3] = GTI_INTERLEAVE_BUFFER;
            }

            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF + 1) != 0) /* As1 Bytes down */
            {
                pWordBuffer[4] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BF + 1);
                pWordBuffer[5] = GTI_FAST_BUFFER;
            }
            else
            {
                pWordBuffer[4] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RATES1_BI + 1);
                pWordBuffer[5] = GTI_INTERLEAVE_BUFFER;
            }

            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7) != 0) /* Ls0 Bytes up */
            {
                pWordBuffer[6] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 7);
                pWordBuffer[7] = GTI_FAST_BUFFER;
            }
            else
            {
                pWordBuffer[6] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BI + 7);
                pWordBuffer[7] = GTI_INTERLEAVE_BUFFER;
            }

            if(GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 8) != 0) /* Ls1 Bytes up */
            {
                pWordBuffer[8] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BF + 8);
                pWordBuffer[9] = GTI_FAST_BUFFER;
            }
            else
            {
                pWordBuffer[8] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RATES1_BI + 8);
                pWordBuffer[9] = GTI_INTERLEAVE_BUFFER;
            }

	    /* U-R2 interop: remote vendor TSTC (CTST=0x43545354xxxx), AS0-=2, LS0-=1 */
            /* Check that standard = G.DMT or G.LITE  */
            tmp1 = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD));
            if( (tmp1 == GTI_G_LITE_STANDARD) || (tmp1 == GTI_G_DMT_STANDARD) ){
                /* Check Vendor ID */
                if( (GET_HOST_DB_B(pSys, GTI_vndIDBlk+2) == 0x54) &&
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+3) == 0x53) &&
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+4) == 0x54) &&
                    (GET_HOST_DB_B(pSys, GTI_vndIDBlk+5) == 0x43) )
                {
		    /* AnnexB interop for U-R2 Siemens DSLAM only */
                    if(GTI_PRIMARY_PROJECT_ID(pSys) == GTI_TYPE_ANNEX_B)
		    {
                        /* AS0 Bytes subtracted by 2 (64kbps) */
                        pWordBuffer[2] -= 0x02;
                        /* LS0 Bytes subtracted by 1 (32kbps) */
                        pWordBuffer[6] -= 0x01;
                    }
                }
            }
            /* U-R2 interop end */
	    


            /***************************/
            /* RRSD Map                */
            /*    HIGH    LOW          */
            /* 0  Dwn-RSi    Dwn-FastR */
            /* 2  Dwn-D      Dwn-S     */
            /* 4  Up-FastR             */
            /* 6  Up-S       Up-RSi    */
            /* 8             Up-D      */
            /***************************/

            /* Fast R RS UP */
            pWordBuffer[10] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 5);

            /* S RS UP */
            pWordBuffer[11] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 7)) & 0x3f);

            /* D RS UP  10 bits*/
            i = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 7) & 0x00c0));
            i = (GTI_WORD)(i << 0x02);
            pWordBuffer[12] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 8)) | i);

            /* R RS UP  = RSi X S*/
            pWordBuffer[13] =
                (GTI_WORD)( (GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 7) & 0x3f) *
                (GET_HOST_DB_B(pSys, GTI_ACTUAL_UP_RRSD + 6) & 0x3f) );

            /* Fast R RS Down */
            pWordBuffer[14] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD);

            /* S RS DOWN */
            pWordBuffer[15] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 2)) & 0x3f);

            /* D RS DOWN  10 bits*/
            i = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 2) & 0x00c0));
            i = (GTI_WORD)(i << 0x02);
            pWordBuffer[16] = (GTI_WORD)((GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 3)) | i);


            /* R RS DOWN  = RSi X S*/
            if (pWordBuffer[15] == 0)  /* S=1/2 case */
            {
                pWordBuffer[17] =
                    (GTI_WORD)(GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 1) & 0x3f);
            }
            else
            {
                pWordBuffer[17] =
                    (GTI_WORD)( (GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 2) & 0x3f) *
                    (GET_HOST_DB_B(pSys, GTI_ACTUAL_DWN_RRSD + 1) & 0x3f) );
            }


            /* Selected Standard */
            pWordBuffer[18] = (GTI_WORD)GET_HOST_DB_B(pSys, GTI_SELCTD_STANDARD);
        }

        break;

    case GTI_ATTENUATION_STATUS:
        /**************************/
        if(nLength >= GTI_ATTENUATION_STATUS_LEN)
        {
            nRetSize = GTI_ATTENUATION_STATUS_LEN;

            /* Local Attenuation */
            if(Gti_GetCurrentMode(pSys) == GTI_CO)
            {
                {
                    /* AnnexABC: Read actual 16 bits and shift down by 3 */
                    j = GET_HOST_DB_W(pSys, GTI_CO_ATTN);
                    j = (GTI_WORD)(j>>3);
                    pByteBuffer[0] = (GTI_BYTE)(j);
                }
                /* Remote - RMsg2 31-25 7bits  */
                pByteBuffer[1] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_R_MSG2 + 3) >> 1);
            }
            else
            {

                #ifdef GTI_LITTLE_ENDIAN
                    /* Local - RMsg2 31-25 7bits  */
                    pByteBuffer[0] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_R_MSG2 + 3) >> 1);
                
                    /* Remote - CMsg2 31-26 6bits  */
                    pByteBuffer[1] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_C_MSG2 + 3) >> 2);
                #elif (defined (GTI_BIG_ENDIAN))
                    /* Local - RMsg2 31-25 7bits  */
                    pByteBuffer[1] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_R_MSG2 + 3) >> 1);                                                        /* Remote - CMsg2 31-26 6bits  */
                    pByteBuffer[0] = (GTI_BYTE)(GET_HOST_DB_B(pSys, GTI_C_MSG2 + 3) >> 2);
                                                                                                                                                #elif
                     NO_ENDIAN_MODE_DEFINED
                  #endif
            }
        }
        break;

    case GTI_UTOPIA_CELL_DROP_COUNT:
        /******************************/
        if(nLength >= GTI_UTOPIA_CELL_DROP_COUNT_LEN)
        {
            CONFIGURE_DSP(pSys, nDspID, GTI_AI);
            WRITE_DSP_ADDR(pSys,nDspID, 0x9c, (GTI_PSRAM0W|GTI_READ_DSP) );

            nRetSize = GTI_UTOPIA_CELL_DROP_COUNT_LEN;

            pWordBuffer[0] = READ_DSP_WORD(pSys, nDspID);
        }
        break;

    case GTI_DUMMY_STATUS:
        /***********************/
        if(nLength >= GTI_DUMMY_STATUS_LEN)
        {
            pByteBuffer[0] = GET_HOST_DB_B(pSys, GTI_DUMMY) ;
            pByteBuffer[1] = GET_HOST_DB_B(pSys, GTI_DUMMY + 1) ;
            nRetSize = GTI_DUMMY_STATUS_LEN;
        }
        break;

    case GTI_RX_TEST_RESULTS_1_64:
    case GTI_RX_TEST_RESULTS_64_128:
    case GTI_RX_TEST_RESULTS_128_192:
    case GTI_RX_TEST_RESULTS_192_256:
        /*******************************/
        if(nLength >= GTI_RX_TEST_RESULTS_LEN)
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_AI);

            if(nStatusType == GTI_RX_TEST_RESULTS_1_64)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 0, (GTI_FDPSRAMA|GTI_READ_DSP));
            }
            else
            if(nStatusType == GTI_RX_TEST_RESULTS_64_128)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 128, (GTI_FDPSRAMA|GTI_READ_DSP));
            }
            else
            if(nStatusType == GTI_RX_TEST_RESULTS_128_192)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 0, (GTI_FDPSRAMB|GTI_READ_DSP));
            }
            else
            if(nStatusType == GTI_RX_TEST_RESULTS_192_256)
            {
                WRITE_DSP_ADDR(pSys, GTI_DSP_A, 128, (GTI_FDPSRAMB|GTI_READ_DSP));
            }

            for(i = 0; i < GTI_RX_TEST_RESULTS_LEN/4; i++)
            {
                GTI_WORD wBin1 = READ_DSP_WORD(pSys, GTI_DSP_A);
                GTI_WORD wBin2 = READ_DSP_WORD(pSys, GTI_DSP_A);

                if(wBin1 & 0x8000) wBin1 = (GTI_WORD)(0xffff - wBin1 + 1);
                if(wBin2 & 0x8000) wBin2 = (GTI_WORD)(0xffff - wBin2 + 1);

                pDWordBuffer[i]  =  (GTI_WORD)(LOBYTE(wBin1) * LOBYTE(wBin1)) +
                    ((GTI_DWORD)(LOBYTE(wBin1) * HIBYTE(wBin1)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin1) * LOBYTE(wBin1)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin1) * HIBYTE(wBin1)) << 0x10) +
                    (GTI_WORD)(LOBYTE(wBin2) * LOBYTE(wBin2)) +
                    ((GTI_DWORD)(LOBYTE(wBin2) * HIBYTE(wBin2)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin2) * LOBYTE(wBin2)) << 0x08) +
                    ((GTI_DWORD)(HIBYTE(wBin2) * HIBYTE(wBin2)) << 0x10);
            }

            nRetSize = GTI_RX_TEST_RESULTS_LEN;
        }
        break;

#ifndef GTI_PAGE_E_BUILT
    case GTI_BIT_SWAP_COUNT:
        /**************************/
        if(nLength >= GTI_BIT_SWAP_COUNT_LEN)
        {
            CONFIGURE_DSP(pSys, GTI_DSP_A, GTI_AI);
            WRITE_DSP_ADDR(pSys, GTI_DSP_A, GTI_host_BSCounter_LOC, (GTI_ISRAM|GTI_READ_DSP));

            pWordBuffer[0] = READ_DSP_WORD(pSys, GTI_DSP_A);

            nRetSize = GTI_BIT_SWAP_COUNT_LEN;
        }
        break;
#endif /* Not Page "E" */

    case GTI_INTERNAL_SAS:
        /********************/
        if(nLength >= GTI_INTERNAL_SAS_LEN)
        {
#ifndef GTI_USE_DMAXFR
            pByteBuffer[0] = pSys->CmdInfo.state;
#else
            CONFIGURE_DSP(pSys, nDspID, GTI_NO_AI);
            WRITE_DSP_ADDR(pSys, nDspID, GTI_DMA_window, GTI_ISRAM|GTI_READ_DSP);
            pByteBuffer[0] = READ_DSP_BYTE(pSys, nDspID, GTI_DATAL_DSP);

#endif
            nRetSize = GTI_INTERNAL_SAS_LEN;
        }
        break;

    case GTI_LINE_DATA_STATUS:
    /************************/
        return Gti_GetLineDataStatus(pSys, pStatus, nLength);

#ifdef GTI_ESC
    case GTI_PM_DATA_STATUS:
    /**********************/
        return Gti_GetPMDataStatus(pSys, pStatus, nLength);
#endif

    default:
        break;

    } /* end of switch */

    return nRetSize;
}
/* End of SStatusXCVR                                                         */
/******************************************************************************/

#ifndef GTI_DEBUG
/****************************************************************************/
/* Procedure: Gti_CopyMemory                              Created: 04.06.98 */
/* ----------------------------                                             */
/* Description: The procedure copies memory buffer                          */
/* -------------------------------------------------------------------------*/
void Gti_CopyMemory(GTI_BYTE GTI_ADDRESS_QUAL *pDst,
                    GTI_BYTE GTI_ADDRESS_QUAL *pSrc, GTI_WORD nCount)
{
    GTI_WORD i;

    for(i=0; i < nCount; i++)
        *(pDst++) = *(pSrc++);
}
#endif
#ifdef GTI_HOST_SASSTATUS
/****************************************************************************/
/* Procedure: Gti_GetBinaryStatus                  Created: 11.26.02        */
/* ----------------------------                                             */
/* Description:                                                             */
/* Return:                                                                  */
/*        0x0000 - Failed. No Status copied to buffer                       */
/*       !0x0000 - Length of # bytes copied to buffer                       */
/* -------------------------------------------------------------------------*/
GTI_WORD
Gti_GetBinaryStatus(GTI_XCVR_INFO *pXcvrInfo,  GTI_WORD nStatusType, GTI_WORD *pWordBuffer, GTI_WORD nLength)
{
  GTI_WORD result;
  GTI_WORD tmp,i;
#ifdef GTI_BUILD_DSP_SEPERATE
  GTI_BYTE GTI_ADDRESS_QUAL *ptmp;
#endif /* Host SAS Status */
  GTI_DWORD dwStatusAddr;

      /* First see if status exists in Common */
      result =Gti_InitPointers(&(pXcvrInfo->StatusInfo), GTI_PAGE_C);
      if(  result != GTI_OK )
      {
           return(0x00);
      }
#ifdef GTI_BUILD_DSP_SEPERATE
      /* Search for matching status */
      ptmp = (GTI_BYTE GTI_ADDRESS_QUAL *)((pXcvrInfo->StatusInfo.PntStatus +
                         (nStatusType*GTI_SIZE_OF_STATUS_PNTR) ) );
      dwStatusAddr =  *(ptmp+0);
      dwStatusAddr |= *(ptmp+1)<<8;
      dwStatusAddr |= *(ptmp+2)<<16;
      dwStatusAddr |= *(ptmp+3)<<24;
#else
      dwStatusAddr = pXcvrInfo->StatusInfo.PntStatus[nStatusType];
#endif /* Host SAS Status */

      /* Check that Command exists. If not then return Not supported */
      if(dwStatusAddr == GTI_EMPTY_ACTION){
          /* Status not supported in Common       */
          /* Then search current Project ID       */
          result =Gti_InitPointers(&(pXcvrInfo->StatusInfo), GTI_PRIMARY_PROJECT_ID(pXcvrInfo));
          if(  result != GTI_OK )
          {
               return(0x00);
          }
          /* Search for matching status */
          #ifdef GTI_BUILD_DSP_SEPERATE
          ptmp = (GTI_BYTE GTI_ADDRESS_QUAL *)((pXcvrInfo->StatusInfo.PntStatus +
                         (nStatusType*GTI_SIZE_OF_STATUS_PNTR) ) );
          dwStatusAddr =  *(ptmp+0);
          dwStatusAddr |= *(ptmp+1)<<8;
          dwStatusAddr |= *(ptmp+2)<<16;
          dwStatusAddr |= *(ptmp+3)<<24;
          #else
          dwStatusAddr = pXcvrInfo->StatusInfo.PntStatus[nStatusType];
          #endif /* Host SAS Status */

          if( dwStatusAddr == GTI_EMPTY_ACTION )
          {
             return(0x00);
          }
      }

      /* Set SAS pointer to Status */
      pXcvrInfo->SASPnt = &pXcvrInfo->StatusInfo; /* Set to command interpeter */

      /* Set Start execution line */
      pXcvrInfo->StatusInfo.table_pnt = (GTI_WORD)dwStatusAddr;

      /* Init length = 0 */
      SET_HOST_DB_B(pXcvrInfo, GTI_HOST_MAILBOX_LEN, 0x00);
      SET_HOST_DB_B(pXcvrInfo, GTI_HOST_MAILBOX_LEN+1, 0x00);

      /* Execute SAS code */
      pXcvrInfo->StatusInfo.state =Gti_StartXcvrCmd(pXcvrInfo);

      if( pXcvrInfo->StatusInfo.state != GTI_COMPLETE_PASS )
      {
           return(0x00);
      }

      /* Check that length matches else fail  */
      tmp = GET_HOST_DB_W(pXcvrInfo, GTI_HOST_MAILBOX_LEN);
      /*printf("Length of result = 0x%x, Length of input buffer =0x%x(bytes)\n",
                    tmp, nLength); */
      if( (nLength/2) < tmp )
      {
          /* mis match in length fail */
           return(0x00);
      }

      /* Copy result to customers buffer      */
      for(  i=0; i < tmp; i++ )
      {
         *(pWordBuffer+i) = GET_HOST_DB_W(pXcvrInfo, GTI_HOST_MAILBOX_MSG+(i*2));
      }

      tmp *=2;
      return(tmp); /* length in words *2 */
}
#endif

