/* 
 * @(#)gti_reg.h	1.6
 */

/***********************************************************************/
/*                                                                     */
/* File: gti_reg.h                                                     */
/* DMT         Application Code-(C) Copyright 1999-1999 by GTI         */
/* This File contains code going to GTI  customers                     */
/* Description: Table used to initialize DSP    registers.             */
/*                                                                     */
/***********************************************************************/
#ifndef  INCLUDE_FILE_GTIREG_H 
#define  INCLUDE_FILE_GTIREG_H


#ifdef __BORLANDC__
#pragma option -zESPEC_INIT -zFSPECIAL 
#endif

/****************FORMAT FOR TABLE*******************/
/* ID, Register #, High byte, low byte             */
/* Where id = GTI_DSP_A                            */
/* Last entry must = GTI_EOT                       */
/**************************************************/


struct GTI_REG_INIT GTI_CONST_QUAL GTI_ADDRESS_QUAL GluelessSARRegTable[]=
{
   { GTI_DSP_A, 0x9d,      0x00, 0x00}, 
   { GTI_DSP_A, 0x9f,      0x30, 0x00}, 
   { GTI_EOT, 0xff,      0xff, 0xff}                    /* this indicates END of table. */
};

struct GTI_REG_INIT GTI_CONST_QUAL GTI_ADDRESS_QUAL Level2RegTable[]=
{
   { GTI_DSP_A, 0x9d,      0x00, 0x00}, 
   { GTI_DSP_A, 0x9f,      0xe0, 0x00}, 
   { GTI_EOT, 0xff,      0xff, 0xff}                    /* this indicates END of table. */
};

struct GTI_REG_INIT GTI_CONST_QUAL GTI_ADDRESS_QUAL Level1RegTable[]=
{
   { GTI_DSP_A, 0x9d,      0x00, 0x00}, 
   { GTI_DSP_A, 0x9f,      0x00, 0x00}, 
   { GTI_EOT, 0xff,      0xff, 0xff}                    /* this indicates END of table. */
};

struct GTI_REG_INIT GTI_CONST_QUAL GTI_ADDRESS_QUAL SerialRegTable[]=
{
   { GTI_DSP_A, 0x9d,      0x81, 0x00}, 
   { GTI_DSP_A, 0x9f,      0x00, 0x83}, 
   { GTI_EOT, 0xff,      0xff, 0xff}                    /* this indicates END of table. */
};


#ifdef __BORLANDC__
#pragma option -zE* -zF* -zH*
#endif

#endif
