/*
 * @(#)gtiextn.h	1.63
 */

/**********************************************************************/
/*            Application Code-(C)Copyright 1995-2003      by GTI     */
/* This File contains code going to GlobeSpan Technologies Inc        */
/* customers                                                          */
/**********************************************************************/

#ifndef  INCLUDE_FILE_GTIEXTN_H
#define  INCLUDE_FILE_GTIEXTN_H

#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)
/* these tables are used for non DMA or XDP transfer only */

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL * GTI_ADDRESS_QUAL A_FarPnt[];
                                  /* GTI Command Tables ROM */
#ifdef GTI_MULTI_PROJ
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_a_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_b_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_c_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_d_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_e_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_f_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_g_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_h_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_i_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_j_tbl[];
GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_k_tbl[];
#endif
#endif

#if ( (defined(GTI_HMS) || defined(GTI_PROD_MSDSL)) && !defined(GTI_DSPOCTANE) )
extern struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdPnt_tbl[];
#endif

GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_a[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_b[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_c[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_d[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_e[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_f[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_g[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_h[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_i[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_j[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_ActionLabelTable_k[];

GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_a[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_b[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_c[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_d[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_e[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_f[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_g[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_h[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_i[];
GTI_EXTERN GTI_DWORD GTI_ADDRESS_QUAL Gti_StatusCmdTbl_j[];

#ifdef GTI_MULTI_PROJ

#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)

/* these tables are used for non DMA  or XDP transfer only */

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_a[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_a[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_a[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_a[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_a[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_a[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_a[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_a[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_a[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_a[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_a[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_a[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_a[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_a[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_a[];


GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_b[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_b[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_b[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_b[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_b[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_b[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_b[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_b[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_b[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_b[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_b[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_b[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_b[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_b[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_b[];


GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_c[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_c[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_c[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_c[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_c[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_c[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_c[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_c[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_c[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_c[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_c[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_c[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_c[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_c[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_c[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_d[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_d[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_d[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_d[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_d[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_d[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_d[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_d[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_d[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_d[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_d[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_d[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_d[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_d[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_d[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_e[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_e[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_e[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_e[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_e[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_e[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_e[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_e[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_e[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_e[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_e[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_e[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_e[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_e[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_e[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_f[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_f[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_f[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_f[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_f[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_f[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_f[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_f[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_f[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_f[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_f[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_f[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_f[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_f[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_f[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_g[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_g[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_g[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_g[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_g[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_g[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_g[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_g[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_g[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_g[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_g[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_g[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_g[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_g[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_g[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_h[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_h[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_h[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_h[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_h[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_h[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_h[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_h[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_h[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_h[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_h[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_h[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_h[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_h[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_h[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_i[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_i[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_i[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_i[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_i[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_i[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_i[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_i[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_i[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_i[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_i[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_i[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_i[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_i[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_i[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_j[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_j[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_j[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_j[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_j[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_j[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_j[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_j[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_j[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_j[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_j[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_j[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_j[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_j[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_j[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_k[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_k[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_k[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_k[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_k[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_k[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_k[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_k[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_k[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_k[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_k[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_k[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_k[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_k[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_k[];

#else
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaStartTable[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaInfoTable[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL Gti_DmaDescTable_k[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_a[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_b[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_c[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_d[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_e[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_f[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_g[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_h[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_i[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_j[];
GTI_EXTERN GTI_CONST_QUAL GTI_REF_TBL_ELEMENT GTI_ADDRESS_QUAL Gti_LbusRefTable_k[];
#endif /* For Non DMA transfer only */

/* GTI Code Tables ROM */
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_a[];
#if (defined(GTI_DSP_PCU_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_a[];
#endif
#if (defined(GTI_DSP_FDP_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_a[];
#endif
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_a[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_b[];
#if (defined(GTI_DSP_PCU_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_b[];
#endif
#if (defined(GTI_DSP_FDP_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_b[];
#endif
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_b[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_c[];
#if (defined(GTI_DSP_PCU_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_c[];
#endif
#if (defined(GTI_DSP_FDP_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_c[];
#endif
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_c[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_d[];
#if (defined(GTI_DSP_PCU_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_d[];
#endif
#if (defined(GTI_DSP_FDP_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_d[];
#endif
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_d[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_e[];
#if (defined(GTI_DSP_PCU_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_e[];
#endif
#if (defined(GTI_DSP_FDP_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_e[];
#endif
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_e[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_f[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_g[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_h[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_i[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_j[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_k[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_k[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_k[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_k[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_k[];

#if (defined(GTI_DSP_PCU_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_k[];
#endif
#if (defined(GTI_DSP_FDP_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_k[];
#endif

                                    /* Only used in CP code */
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_g[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_h[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_i[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_j[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL XDP_code_k[];

#ifdef GTI_PROD_MADSL

GTI_EXTERN struct CMDPOINT GTI_CONST_QUAL GTI_ADDRESS_QUAL YAT_tbl_radsl[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_radsl_a[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_radsl_a[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_radsl_a[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_radsl_a[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_radsl_a[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_radsl_a[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_radsl_a[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_radsl_a[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_radsl_a[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_radsl_a[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_radsl_a[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_radsl_a[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_radsl_a[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_radsl_a[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_radsl_a[];



GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_radsl_b[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_radsl_b[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_radsl_b[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_radsl_b[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_radsl_b[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_radsl_b[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_radsl_b[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_radsl_b[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_radsl_b[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_radsl_b[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_radsl_b[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_radsl_b[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_radsl_b[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_radsl_b[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_radsl_b[];


GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_radsl_c[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_radsl_c[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_radsl_c[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_radsl_c[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_radsl_c[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_radsl_c[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_radsl_c[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_radsl_c[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_radsl_c[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_radsl_c[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_radsl_c[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_radsl_c[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_radsl_c[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_radsl_c[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_radsl_c[];


GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_radsl_d[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_radsl_d[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_radsl_d[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_radsl_d[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_radsl_d[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_radsl_d[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_radsl_d[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_radsl_d[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_radsl_d[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_radsl_d[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_radsl_d[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_radsl_d[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_radsl_d[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_radsl_d[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_radsl_d[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_radsl_e[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_radsl_e[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_radsl_e[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_radsl_e[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_radsl_e[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_radsl_e[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_radsl_e[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_radsl_e[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_radsl_e[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_radsl_e[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_radsl_e[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_radsl_e[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_radsl_e[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_radsl_e[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_radsl_e[];

GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable_radsl_f[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl_radsl_f[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl_radsl_f[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl_radsl_f[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl_radsl_f[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl_radsl_f[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl_radsl_f[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl_radsl_f[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl_radsl_f[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl_radsl_f[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl_radsl_f[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl_radsl_f[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl_radsl_f[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl_radsl_f[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl_radsl_f[];


                                  /* GTI Code Tables    ROM*/
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_radsl_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_radsl_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_radsl_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_radsl_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_radsl_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_radsl_a[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_radsl_a[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_radsl_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_radsl_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_radsl_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_radsl_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_radsl_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_radsl_b[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_radsl_b[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_radsl_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_radsl_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_radsl_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_radsl_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_radsl_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_radsl_c[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_radsl_c[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_radsl_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_radsl_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_radsl_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_radsl_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_radsl_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_radsl_d[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_radsl_d[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_radsl_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_radsl_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_radsl_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_radsl_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_radsl_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_radsl_e[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_radsl_e[];

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code_radsl_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code_radsl_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code_radsl_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code_radsl_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code_radsl_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code_radsl_f[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code_radsl_f[];

#endif  /*GTI_PROD_MADSL*/

#else
                        /* Single Project System */
GTI_EXTERN struct BASIC_CMD GTI_CONST_QUAL GTI_ADDRESS_QUAL CmdTable[];
GTI_EXTERN struct MEM_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEML_tbl[];
GTI_EXTERN struct TIMEOUT_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Time_tbl[];
GTI_EXTERN struct FILL_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fill_tbl[];
GTI_EXTERN struct DELAY_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Delay_tbl[];
GTI_EXTERN struct FUN_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL Fun_tbl[];
GTI_EXTERN struct REG_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGL_tbl[];
GTI_EXTERN struct REG_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGR_tbl[];
GTI_EXTERN struct MEM_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL MEMR_tbl[];
GTI_EXTERN struct HOST_2_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL HOSTL_tbl[];
GTI_EXTERN struct IMM_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMML_tbl[];
GTI_EXTERN struct IMM_2_READ_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IMMR_tbl[];
GTI_EXTERN struct REG_LOADIND_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL REGLInd_tbl[];
GTI_EXTERN struct IND_1_LOAD_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL INDL_tbl[];
GTI_EXTERN struct IF_STRUCT GTI_CONST_QUAL GTI_ADDRESS_QUAL IF_tbl[];

                                  /* GTI Code Tables    ROM*/

GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL IPU_code[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL TR_code[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL BE_code[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL AVM_code[];
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL COEF_code[];
#if (defined(GTI_DSP_PCU_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL PCU_code[];
#endif
#if (defined(GTI_DSP_FDP_ENG))
GTI_EXTERN GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL FDP_code[];
#endif

#endif

#ifdef GTI_BUILD_DSP_SEPERATE
/*GTI_EXTERN GTI_DWORD BinaryBaseAddress;*/
GTI_EXTERN GTI_CONST_QUAL GTI_BYTE GTI_ADDRESS_QUAL *BinaryBaseAddress;
#endif


                                  /* DEBUG Space */
#ifdef GTI_TRACE
GTI_EXTERN GTI_WORD HistPnt;

GTI_EXTERN GTI_WORD HistTimeStamp[GTI_SIZE_OF_TRACE];

GTI_EXTERN GTI_WORD History[3][GTI_SIZE_OF_TRACE];
GTI_EXTERN GTI_WORD SASStop_line;
GTI_EXTERN GTI_BYTE SASStop_baud;
GTI_EXTERN GTI_BYTE SASStop_hip;
GTI_EXTERN GTI_BYTE SASStop_enable;
#endif
#ifdef GTI_DEBUG
GTI_EXTERN GTI_BYTE FlgGetHIPCmd;
GTI_EXTERN GTI_BYTE GotChar;
#endif

#if defined(GTI_PROD_DMT)
#if defined(GTI_USE_GLOBAL_BUFFER_FOR_LARGE_STATUS)
extern GTI_BYTE g_bBinsStatusBuffer[GTI_BINS_STATUS_BUFF_LEN]; /* Used for 512 Bits/Bin status */
#endif
#endif


/**********************************************************/
/*  Instructions for modifications to use one controller  */
/*  for MORE THEN ONE XCVR system                         */
/*  1) file gtiram.c                                      */
/*     In Mult XCVR systems declare the Command structure */
/*     (GTI_XCVR_INFO xxyyzz) as local variables in  */
/*     the routine that calls:                            */
/*          ExecuteXCVR,ParamXCVR,Param...                */
/*                                                        */
/*  2) file gtiinit.c                                     */
/*     Every Command Struct (GTI_XCVR_INFO xxyyzz)   */
/*     used must be initialized once.                     */
/*     This is done be calling InitXCVR_CS(&xxyyzz,..)    */
/*     and InitXCVR(&xxyyzz)                              */
/*     Where xxyyzz is the address of a GTI_XCVR_INFO       */
/*     structure                                          */
/*                                                        */
/*  3) usage                                              */
/*     Pass GTI routines the Address of the Command Struct*/
/*     being used for that XCVR.                          */
/*     i.e. ExecuteXCVR(&xxyyzz)                          */
/*                                                        */
/*  4) It is the responsibility of the customer to insure */
/*     the drivers (WriteBlock....) are accessing the     */
/*     correct XCVR System                                */
/**********************************************************/

GTI_EXTERN GTI_XCVR_INFO  GTI_GLOBAL_QUAL  GTIXcvr[];
GTI_EXTERN GTI_CHIP_INFO  GTI_GLOBAL_QUAL  GTIChip[];
GTI_EXTERN GTI_CUST_INFO  GTI_GLOBAL_QUAL  GTICust[];
#if (defined(GTI_USE_XDPXFR) || defined(GTI_USE_DMAXFR))
GTI_EXTERN GTI_LBUS_INFO  GTI_GLOBAL_QUAL  GTILbus[];
#endif
GTI_EXTERN GTI_SYST_INFO  GTI_GLOBAL_QUAL  GtiSystemDB;

                                  /* HIP */
GTI_EXTERN GTI_BYTE GTI_GLOBAL_QUAL HIP_Mail[];
GTI_EXTERN GTI_BYTE GTI_GLOBAL_QUAL HIP_Param[];


void SwitchXCVR(GTI_BYTE);
void ResetDSP(GTI_XCVR_INFO *,GTI_BYTE);

                                /* Prototype External Framer Drivers */
void WriteADSLFramerW(GTI_XCVR_INFO *,GTI_BYTE,GTI_WORD);
void WriteHDSLFramerB(GTI_XCVR_INFO *,GTI_BYTE,GTI_BYTE);
GTI_BYTE ReadFramer(GTI_XCVR_INFO *,GTI_BYTE);
        /* INTERNAL APPLICATIONS */
#ifdef GTI_DEBUG
void WriteRAMHE1T1(GTI_XCVR_INFO *,GTI_BYTE,GTI_BYTE);
void WriteRAMLE1T1(GTI_XCVR_INFO *,GTI_BYTE,GTI_BYTE);
GTI_BYTE ReadRAMHE1T1(GTI_XCVR_INFO *,GTI_BYTE);
GTI_BYTE ReadRAMLE1T1(GTI_XCVR_INFO *,GTI_BYTE);
#endif

#if defined(GTI_USE_CUSTOMER_DEFINED_IO)
    GTI_EXTERN GTI_BYTE Gti_GetRegDspIO(GTI_XCVR_INFO *, GTI_BYTE);
    GTI_EXTERN GTI_BYTE Gti_GetByteDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE);
    GTI_EXTERN GTI_WORD Gti_GetWordDspIO(GTI_XCVR_INFO *, GTI_BYTE);
    GTI_EXTERN void Gti_SetRegDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE, GTI_BYTE);
    GTI_EXTERN void Gti_UpdateDspIO(GTI_XCVR_INFO *);
    GTI_EXTERN void Gti_SetByteDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE, GTI_BYTE);
    GTI_EXTERN void Gti_SetWordDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE, GTI_BYTE);
    GTI_EXTERN void Gti_SetBlockDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE, GTI_WORD,
                   GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *);
    GTI_EXTERN void Gti_GetBlockDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_WORD, GTI_BYTE *);
    GTI_EXTERN void Gti_GetExtBlockDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_WORD, GTI_BYTE*);
    GTI_EXTERN void Gti_SetSpecialDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE, GTI_BYTE, GTI_BYTE);
    GTI_EXTERN void Gti_SetAddrDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE, GTI_BYTE);
    GTI_EXTERN void Gti_ConfigureDspIO(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE);
#else
    /* Prototype Drivers */
    /* supplied by customer*/
    GTI_EXTERN void WriteStarB(GTI_XCVR_INFO *,GTI_BYTE,GTI_BYTE,GTI_BYTE);
    GTI_EXTERN void WriteStarBlock(GTI_XCVR_INFO *, GTI_BYTE,GTI_BYTE,GTI_WORD, GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *);
    GTI_EXTERN void WriteStarW(GTI_XCVR_INFO *, GTI_BYTE,GTI_BYTE,GTI_BYTE);
    GTI_EXTERN void WriteDspAdd(GTI_XCVR_INFO *, GTI_BYTE,GTI_BYTE,GTI_BYTE);
    GTI_EXTERN GTI_WORD ReadStarW(GTI_XCVR_INFO *,GTI_BYTE);
    GTI_EXTERN GTI_BYTE ReadStarB(GTI_XCVR_INFO *,GTI_BYTE,GTI_BYTE);
#if (defined (GTI_DSPOCTANE)|| defined (GTI_DSPVIKING))
    GTI_EXTERN void ReadStarBlock(GTI_XCVR_INFO *, GTI_BYTE, GTI_BYTE, GTI_WORD, GTI_BYTE GTI_ADDRESS_QUAL *);
    GTI_EXTERN void ReadStarExtBlock(GTI_XCVR_INFO*, GTI_BYTE, GTI_BYTE, GTI_WORD, GTI_BYTE GTI_ADDRESS_QUAL *);
#endif
#ifdef GTI_DSPTURBO
    GTI_WORD GtiGetCoreMask(GTI_XCVR_INFO*, GTI_BYTE);
    GTI_WORD GtiTranslateRegister(GTI_XCVR_INFO*, GTI_WORD, GTI_BYTE);
    GTI_WORD GtiTranslatePhysicalA(GTI_WORD);
    GTI_WORD GtiTranslatePhysicalB(GTI_WORD);
    GTI_WORD GtiTranslatePhysicalAB(GTI_WORD);
#endif
#endif
                                /* Prototype of routines */
                                /* Supplied by GTI       */

GTI_WORD Gti_ExecuteXCVR(GTI_XCVR_INFO *);
GTI_WORD Gti_GetParamXCVR(GTI_XCVR_INFO *,
                      struct PARAM_XCVR_ARRAY * );
GTI_WORD Gti_SetParamXCVR(GTI_XCVR_INFO *,
                      struct PARAM_XCVR_ARRAY * );

                                /* Prototype of routines */
                                /* Used by GTI supplied  */
                                /* routines              */
GTI_BYTE Gti_StartXcvrCmd(GTI_XCVR_INFO *);

#ifdef GTI_DEBUG_WHIP
GTI_WORD Gti_SStatusXCVR(GTI_XCVR_INFO *,  /* System Pointer                  */
                         GTI_WORD ,        /* type of required status         */
                         void *,           /* Pointer to the status buffer    */
                         GTI_WORD ,        /* Maximum length of the buffer    */
                         GTI_BYTE );

#else
GTI_BYTE StatusXCVR( GTI_XCVR_INFO *,GTI_BYTE *);
#endif

#ifdef GTI_TRACE
void Gti_EnableTraceOutput( GTI_XCVR_INFO *, GTI_WORD );
void Gti_UpdateTrace( GTI_WORD, GTI_WORD);
#endif

void Gti_ParseMEMLoad(GTI_XCVR_INFO *);
void Gti_ParseCACHELoad(GTI_XCVR_INFO *);
void Gti_ParseMEMR(GTI_XCVR_INFO *);
void Gti_ParseTIME(GTI_XCVR_INFO *);
void Gti_ParseFILL(GTI_XCVR_INFO *);
void Gti_ParseDELAY(GTI_XCVR_INFO *);
void Gti_ParseFUN(GTI_XCVR_INFO *);
void Gti_ParseREGL(GTI_XCVR_INFO *);
void Gti_ParseREGR(GTI_XCVR_INFO *);
void Gti_ParseHOSTL(GTI_XCVR_INFO *);
void Gti_ParseIMML(GTI_XCVR_INFO *);
void Gti_ParseIMMR(GTI_XCVR_INFO *);
void Gti_ParseREGInd(GTI_XCVR_INFO *);
void Gti_ParseINDL(GTI_XCVR_INFO *);
void Gti_ParseIF(GTI_XCVR_INFO *);
GTI_WORD Gti_ParseCONTEX(GTI_XCVR_INFO *);
void Gti_SendCodeROM(GTI_XCVR_INFO *,
                  GTI_BYTE,GTI_BYTE,
                  GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *,
                  GTI_WORD, GTI_WORD);
void Gti_SendSpecialROM(GTI_XCVR_INFO *,
                    GTI_BYTE, GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *, GTI_WORD, GTI_WORD);
void Gti_SendWordRAM(GTI_XCVR_INFO *,GTI_BYTE,GTI_BYTE, GTI_WORD, GTI_WORD);
GTI_BYTE Gti_GetWordSize(GTI_BYTE);
GTI_BYTE Gti_GetWordBitSize(GTI_BYTE );

void Gti_ConfigReadRdy(GTI_XCVR_INFO *);
GTI_BYTE Gti_IsIPUready(GTI_XCVR_INFO *);
GTI_WORD Gti_GetNextState(GTI_XCVR_INFO *);

void InitXCVR_CS(GTI_XCVR_INFO *, GTI_CS_ADDRESS, GTI_CS_ADDRESS,
#ifdef GTI_PROD_DMT
     GTI_CS_ADDRESS, GTI_CS_ADDRESS, GTI_CS_ADDRESS , GTI_WORD);
#else
     GTI_CS_ADDRESS, GTI_CS_ADDRESS, GTI_CS_ADDRESS );
#endif

#define InitXCVR                    Gti_InitXCVR
#define InitSTARInterrupt           Gti_InitDSPInterrupt
#define ClearSTARInterrupt          Gti_ClearDSPInterrupt
#define InitFRAMERInterrupt         Gti_InitFRAMERInterrupt
#define ClearFRAMERInterrupt        Gti_ClearFRAMERInterrupt
#define SStatusXCVR                 Gti_SStatusXCVR
#define ExecuteXCVR                 Gti_ExecuteXCVR
#define BackgroundExecXCVR          Gti_BackgroundExecXCVR
#define UtopiaEnableOddAddress      Gti_UtopiaEnableOddAddress
#define ParamSetIO                  Gti_ParamSetIO
#define SetParamXCVR                Gti_SetParamXCVR
#define SetParamFramer              Gti_SetParamFramer
#define InitPointers                Gti_InitPointers

/* The following functions are used to create and initialize the GTI system */
void Gti_BuildSystem(GTI_SYST_INFO *);
void Gti_BuildCHIP(GTI_SYST_INFO *, GTI_CHIP_INFO *, GTI_CUST_INFO *, int);
void Gti_BuildXCVR(GTI_CHIP_INFO *, GTI_XCVR_INFO *, int);
#ifdef GTI_BUILD_DSP_SEPERATE
GTI_WORD
Gti_SetBinaryBaseAddress(
   GTI_XCVR_INFO *pXcvrInfo,   /* A pointer to the built XCVR Data Base      */
   GTI_CONST_QUAL GTI_BYTE GTI_ADDRESS_QUAL *pntBinary
);
GTI_WORD
Gti_ReportSupportedAnnexes(
                 GTI_SUPPORTED_ANNEX_STATUS *pResultAnnex,
                 GTI_WORD maxReportedAnnexes );
#endif /*GTI_BUILD_DSP_SEPERATE */


int  Gti_InitSystem(GTI_SYST_INFO *);
void Gti_InitCHIP(GTI_CHIP_INFO *);
void Gti_InitXCVR(GTI_XCVR_INFO *);
int  Gti_InitLBUS(GTI_SYST_INFO *, int);
void Gti_StopDspActivity(GTI_XCVR_INFO*);

#if defined(GTI_DSPQUAD) || defined(GTI_DSPOCTANE)
GTI_WORD Gti_ShutDwnXcvr(GTI_XCVR_INFO* pXcvrInfo, GTI_BYTE bHwId);
#endif

#ifdef GTI_DSPQUAD
void Gti_SetTopVCO( GTI_XCVR_INFO* pXcvrInfo);
#endif

#ifdef GTI_PROD_DMT
void Gti_SetExpectedStandard(GTI_XCVR_INFO *, GTI_BYTE);
#endif

#if defined(GTI_USE_DMAXFR)
void Gti_SetLocalBusNumber(GTI_CHIP_INFO *, GTI_WORD);
#endif

#if defined(GTI_USE_XDPXFR)
void Gti_SetLocalBusNumber( GTI_CHIP_INFO *, GTI_LBUS_INFO *, GTI_WORD);
#endif

void Gti_ClearDSPInterrupt(GTI_XCVR_INFO *, GTI_BYTE );
void Gti_InitDSPInterrupt(GTI_XCVR_INFO *, GTI_BYTE );

#if defined(GTI_DSPOCTANE)
void Gti_ClearDSPIntAll(GTI_XCVR_INFO *pXcvrInfo);
#endif

void Gti_ClearFRAMERInterrupt(GTI_XCVR_INFO *, GTI_BYTE );
void Gti_InitFRAMERInterrupt(GTI_XCVR_INFO *, GTI_BYTE );

void Gti_InitISRAM(GTI_XCVR_INFO *);
void Gti_InitSLADE(GTI_XCVR_INFO *);
void Gti_InitDSP(GTI_XCVR_INFO *);
void Gti_InitHRAM(GTI_XCVR_INFO *);
void Gti_InitAFE(GTI_XCVR_INFO *);
void Gti_TurnOnAFE(GTI_XCVR_INFO *);
void Gti_TurnOffAFE(GTI_XCVR_INFO *);
void Gti_InitProductHRAM( GTI_XCVR_INFO * );
void Gti_WaitIPU(GTI_XCVR_INFO *);
GTI_WORD Gti_ConvertCoarseDB(GTI_WORD);
GTI_WORD Gti_ConvertFineDB(GTI_WORD);
GTI_WORD Gti_ConvertSuperDB(GTI_WORD);
GTI_WORD Gti_InitPointers( GTI_SAS_INFO *, GTI_BYTE);

#ifndef GTI_DEBUG
#ifndef GTI_USE_MEMCPY
    void Gti_CopyMemory(GTI_BYTE GTI_ADDRESS_QUAL *,
                    GTI_BYTE GTI_ADDRESS_QUAL *, GTI_WORD );
#ifdef memcpy
#undef memcpy
#endif
#define memcpy(a,b,c) Gti_CopyMemory( (GTI_BYTE GTI_ADDRESS_QUAL*)a, \
                                  (GTI_BYTE GTI_ADDRESS_QUAL*)b, (GTI_WORD)c)
#endif
#endif

                                /* Porototype for HIP routines */
#ifndef GTI_DEBUG_WHIP
void HIP2XCVR(GTI_XCVR_INFO *);
void Gti_SerialTXChar(GTI_BYTE);
void Gti_ReadHost(GTI_XCVR_INFO *);
void Gti_WriteHost(GTI_XCVR_INFO *);
void Gti_ReadRam(GTI_XCVR_INFO *);
void GTIWriteRam(GTI_XCVR_INFO *);
void Gti_ExCommand(GTI_XCVR_INFO *);
void Gti_GetStatus(GTI_XCVR_INFO *);
void Gti_ParamExec(GTI_XCVR_INFO *);
void Gti_CheckHIPCmd(GTI_XCVR_INFO *);
void Gti_ClockHIP(GTI_XCVR_INFO *);
void Gti_ParamSetHIP(GTI_XCVR_INFO *);
void Gti_WriteFramerHIP(GTI_XCVR_INFO *);
void Gti_ReadFramerHIP(GTI_XCVR_INFO *);
void Gti_CodeRead(GTI_XCVR_INFO *);
void Gti_CodeWrite(GTI_XCVR_INFO *);
void Gti_StarInterrupt(GTI_XCVR_INFO *);
void Gti_SwitchXCVR(void);
void Gti_InfoInt(void);
void Gti_RxTxInterface(GTI_XCVR_INFO *);
void Gti_SetTimeSlot(GTI_XCVR_INFO *);
void Gti_SyncFramer(GTI_XCVR_INFO *);
void Gti_SetFrmParam(GTI_XCVR_INFO *);
void Gti_SetFrmClamp(GTI_XCVR_INFO *);
void Gti_SetInsertError(GTI_XCVR_INFO *);
#endif

#if (defined (GTI_PROD_H2B1Q) || defined (GTI_PROD_HDSL2) || defined (GTI_PROD_MSDSL) || defined (GTI_PROD_HDSL4W) )
void Gti_EOCData(GTI_XCVR_INFO *);
void Gti_SetGenericFramerParam(GTI_XCVR_INFO *);
#endif

#if (defined (GTI_PROD_M2B1Q))
void Gti_F3Cell(GTI_XCVR_INFO *);
#endif

#if (defined (GTI_PROD_IDSL)|| defined (GTI_PROD_MSDSL))
void Gti_SetPin(GTI_XCVR_INFO *);
#endif

#ifdef GTI_TRACE
void Gti_SASHistory(void);
void Gti_SASStop(void);
#endif

#ifdef GTI_DEBUG_WHIP
GTI_EXTERN void Gti_BackgroundExecXCVR(void);
#endif

/* Prototype of routines   */
/* Called by Command table */
GTI_BYTE Gti_GenFun1(void);
GTI_BYTE Gti_GenFun2(void);

void Gti_CopyHostDBToDsp(GTI_XCVR_INFO* , GTI_BYTE , GTI_WORD , GTI_BYTE , GTI_WORD );
void Gti_CopyHostDBToHostDB(GTI_XCVR_INFO* , GTI_WORD , GTI_WORD , GTI_WORD );

#if defined(GTI_USE_DMAXFR) || defined(GTI_USE_XDPXFR)
    GTI_EXTERN GTI_BYTE Gti_GetHostDB(GTI_XCVR_INFO* , GTI_WORD );
    GTI_EXTERN GTI_WORD Gti_GetHostDW(GTI_XCVR_INFO* , GTI_WORD );
    GTI_EXTERN void Gti_GetHostDBlock(GTI_XCVR_INFO*, GTI_WORD, GTI_WORD, GTI_BYTE *);
    GTI_EXTERN void Gti_SetHostDB(GTI_XCVR_INFO*, GTI_WORD, GTI_BYTE);

#if defined(GTI_USE_DMAXFR)
    #define GET_HOST_DB_W(pXcvrInfo,wAddr) ((GTI_WORD)   \
            (MAKEWORD(Gti_GetHostDB((pXcvrInfo),(wAddr)), Gti_GetHostDB((pXcvrInfo), ((wAddr)+1)))))
#else
    #define GET_HOST_DB_W(pXcvrInfo,wAddr) ((GTI_WORD)Gti_GetHostDW((pXcvrInfo), ((wAddr))))
#endif
    #define GET_HOST_DB_B(pXcvrInfo,wAddr) ((GTI_BYTE)   \
            (Gti_GetHostDB((pXcvrInfo),(GTI_WORD)(wAddr))))

    #define GET_HOST_DB_BLOCK(pXcvrInfo,wAddr,wLen,pBuf) (  \
            (Gti_GetHostDBlock((pXcvrInfo),(GTI_WORD)(wAddr),(GTI_WORD)(wLen),(GTI_BYTE *)(pBuf))))

#ifndef GTI_USE_XDPXFR /* No 1 byte writes in XDP mode */
    #define SET_HOST_DB_B(pXcvrInfo,wAddr,bData)        \
            Gti_SetHostDB((pXcvrInfo),(GTI_WORD)(wAddr),(GTI_BYTE)(bData))
#endif

#ifdef GTI_USE_XDPXFR
    GTI_EXTERN void Gti_SetHostDW(GTI_XCVR_INFO*, GTI_WORD, GTI_WORD);
    #define SET_HOST_DB_W(pXcvrInfo,wAddr,wData)                       \
            Gti_SetHostDW((pXcvrInfo),(GTI_WORD)((wAddr)),(GTI_WORD)(wData))
#else
    #define SET_HOST_DB_W(pXcvrInfo,wAddr,wData)                       \
            Gti_SetHostDB((pXcvrInfo),(GTI_WORD)(wAddr),LOBYTE(wData));  \
            Gti_SetHostDB((pXcvrInfo),(GTI_WORD)((wAddr)+1),HIBYTE(wData))
#endif

    #define GET_HOST_DB_PTR(pXcvrInf) ((void*)0)

#else
    GTI_EXTERN GTI_BYTE Gti_GetHostDB(GTI_XCVR_INFO* , GTI_WORD );
    GTI_EXTERN void Gti_SetHostDB(GTI_XCVR_INFO* , GTI_WORD , GTI_BYTE );
    #define GET_HOST_DB_B(pXcvrInfo,wAddr) ((GTI_BYTE)((pXcvrInfo)->paramsDB[(wAddr)]))

    #define GET_HOST_DB_W(pXcvrInfo,wAddr) ((GTI_WORD)   \
            (MAKEWORD(GET_HOST_DB_B((pXcvrInfo),(wAddr)), GET_HOST_DB_B((pXcvrInfo), ((wAddr)+1)))))

    #define SET_HOST_DB_B(pXcvrInfo,wAddr,bData) (((pXcvrInfo)->paramsDB[(wAddr)] = (GTI_BYTE)(bData)))

    #define SET_HOST_DB_W(pXcvrInfo,wAddr,wData)                 \
            (pXcvrInfo)->paramsDB[(wAddr)] = LOBYTE(wData);      \
            (pXcvrInfo)->paramsDB[(wAddr)+1] = HIBYTE(wData)

    #define GET_HOST_DB_BLOCK(pXcvrInfo,wAddr,wLen,pBuf)  {             \
            GTI_WORD _wCnt;                                     \
            for(_wCnt=0;_wCnt < (wLen); _wCnt++)  \
                pBuf[_wCnt] = GET_HOST_DB_B(pXcvrInfo,wAddr);           \
            }

    #define GET_HOST_DB_PTR(pXcvrInf) (pXcvrInfo->paramsDB)

#endif

#ifdef GTI_DEBUG_WHIP

    GTI_EXTERN WHIP_BRKPNT_DATA Whip_BrkPntData[L2_MAX_BREAKPOINTS];
    GTI_EXTERN GTI_WORD wsp_length;
    GTI_EXTERN GTI_BYTE  wsp_buffer[];

    GTI_EXTERN GTI_BYTE  WhipCurrentSessionID ;
    GTI_EXTERN GTI_BYTE  WhipMessageID ;

#ifndef GTI_USE_INTERNAL_TARGET
    GTI_EXTERN GTI_DWORD WhipMessagesReceived ;
    GTI_EXTERN GTI_WORD  WhipLastSOMidx;
    GTI_EXTERN GTI_DWORD WhipRexmtCounter;

    GTI_EXTERN GTI_BYTE  Whip_state;

    GTI_EXTERN GTI_WORD  Whip_rcv_bufidx;
    GTI_EXTERN GTI_BYTE  Whip_chksum;
    GTI_EXTERN GTI_BYTE  Whip_rcv_buffer[L2_RCV_BUF_MAX];

    GTI_EXTERN GTI_BYTE  Whip_xmt_buffer[L2_XMT_BUF_MAX];
    GTI_EXTERN GTI_WORD  Whip_xmt_total_idx;
    GTI_EXTERN GTI_WORD  Whip_xmt_sentb_idx;
#endif /* !Internal Target */

    GTI_EXTERN GTI_BYTE WhipActiveXcvr;
    GTI_EXTERN char WhipTargetName[6];
    GTI_EXTERN GTI_XCVR_INFO GTI_GLOBAL_QUAL *WhipGtiXcvrPtr;
    GTI_EXTERN GTI_BYTE WhipEocEnabled;

#ifdef GS_USE_LEGACY
    GS_EXTERN void Gti_WhipRxHandler(GS_SYST_INFO* pSystInfo);
    GS_EXTERN void Gti_WhipInit(GS_SYST_INFO* pSystInfo);
#else
    GTI_EXTERN void Gti_WhipRxHandler(GTI_BYTE *pBuffer, GTI_WORD wLength);
    GTI_EXTERN void Gti_WhipInit(void);
#endif

    #define WhipIntSpSendArray Gti_WhipTx
    #ifdef GS_USE_LEGACY
    #define WhipAnalyzeMsg() Gti_WhipRxHandler(pSystInfo)
    #else
    #define WhipAnalyzeMsg() Gti_WhipRxHandler(wsp_buffer,wsp_length)
    #endif
    #define WhipProtocolInit Gti_WhipInit
#endif /* WHIP */

/************************ Define your own Trace Timer here *****************************/
#ifdef GTI_DEBUG
    GTI_EXTERN void ResetTraceTimer_188(void);
    GTI_EXTERN GTI_WORD ReadTraceTimer_188(void);
    #define READ_TRACE_TIMER() ReadTraceTimer_188()
    #define RESET_TRACE_TIMER() ResetTraceTimer_188()
#else
    #define READ_TRACE_TIMER() 0xffff
    #define RESET_TRACE_TIMER()
#endif
/***************************************************************************************/

#define GTI_PRIMARY_PROJECT_ID(pXcvrInfo) pXcvrInfo->bActiveProjectId
#define Gti_GetCurrentAnnexType(pXcvrInfo) pXcvrInfo->bActiveProjectId
#define Gti_GetCurrentMode(pXcvrInfo) pXcvrInfo->CurrentMode

GTI_BYTE Gti_GetChipVersion(GTI_XCVR_INFO *pSys);
GTI_BYTE Gti_GetAfeVersion(GTI_XCVR_INFO *pSys);

GTI_WORD Gti_LocalBusTest(GTI_XCVR_INFO*, GTI_DWORD, GTI_DWORD, GTI_DWORD *);

#ifdef GTI_USE_DMAXFR
void     Gti_ResetDMAEngine(GTI_XCVR_INFO*);
void     Gti_SetLocalBusAnnexType(GTI_SYST_INFO *pSystInfo, int, int);
GTI_WORD Gti_StartCommand (GTI_XCVR_INFO* );
GTI_WORD Gti_LocalBusChkSum(GTI_XCVR_INFO*, GTI_BYTE, GTI_WORD *);
GTI_DWORD Gti_GetDSPLoadedCodeLength(GTI_XCVR_INFO*, GTI_WORD *);
void     Gti_ResetHostDB(GTI_XCVR_INFO*, GTI_WORD, GTI_WORD);
int      Gti_IsCXfrActive(GTI_XCVR_INFO* );
int Gti_LocalBusLoad(GTI_SYST_INFO *, int);
GTI_WORD Gti_ExecuteLbusLoad(GTI_SYST_INFO *, int, GTI_WORD);

#endif

#ifdef GTI_USE_XDPXFR
int Gti_IsCXfrActive(GTI_XCVR_INFO* pXcvrInfo);
GTI_WORD Gti_AddLbusFwImage(GTI_LBUS_INFO *pLbusInfo, GTI_DSP_TBL_ELEMENT GTI_ADDRESS_QUAL *pTblDesc);
int Gti_IsXcvrReady(GTI_XCVR_INFO* pXcvrInfo);
void Gti_ChipActivate(GTI_CHIP_INFO* pChipPtr, GTI_WORD wActivate);
void Gti_LocalBusActivate(GTI_XCVR_INFO* pXcvrPtr, GTI_WORD wActivate);
GTI_WORD Gti_ExecuteLbusLoad(GTI_LBUS_INFO *pLbusInfo, GTI_WORD wMode);
void Gti_ReconfigureLocalBus(GTI_LBUS_INFO *pLbusInfo);
void Gti_BuildLbus(GTI_LBUS_INFO *pLbusInfo);
int Gti_LocalBusLoad(GTI_LBUS_INFO *pSystInfo);
GTI_WORD Gti_BuildDspMsg(GTI_XCVR_INFO *pXcvrInfo, GTI_WORD wIndex, GTI_WORD wMsgId, GTI_WORD wFrameN, GTI_WORD nLen, GTI_WORD *pBuf);
GTI_WORD Gti_SendDspMsg(GTI_XCVR_INFO *pXcvrInfo);
GTI_WORD Gti_LocalBusChkSum(GTI_XCVR_INFO*, GTI_BYTE, GTI_WORD *, GTI_WORD *, GTI_DWORD *);
GTI_WORD Gti_AccessProjectCode(GTI_XCVR_INFO*, GTI_BYTE, GTI_BYTE, GTI_WORD, GTI_WORD, GTI_WORD, GTI_BYTE *);
#endif

GTI_WORD Gti_SetSasBreakpoint(GTI_XCVR_INFO *, GTI_WORD, GTI_WORD, GTI_WORD, GTI_BYTE *);
void Gti_SetDspBreakpoint(GTI_XCVR_INFO *, GTI_BYTE, GTI_WORD, GTI_WORD, GTI_WORD, GTI_BYTE *, GTI_WORD);

#if !defined(GTI_USE_DMAXFR) && !defined(GTI_USE_XDPXFR)
#define Gti_IsCXfrActive(pXcvrInfo) (pXcvrInfo->CmdInfo.state == GTI_ACTIVE) /* SAS for Commands */
#endif

GTI_BYTE Gti_GetActiveProjectId(GTI_XCVR_INFO*);

void Gti_SetVCO( GTI_XCVR_INFO* pXcvrInfo, int nInit);

#if (defined (GTI_USE_XDPXFR) || defined(GTI_USE_DMAXFR))
GTI_WORD Gti_GetLocalBusDspLoadStatus(GTI_SYST_INFO *pSystInfo, int nLbusNum);
GTI_WORD Gti_SetLbusFwImage(GTI_SYST_INFO *pSystInfo, int nLbusNum,
    GTI_DSP_TBL_ELEMENT GTI_ADDRESS_QUAL *pTable, GTI_WORD wElements);
int Gti_LoadSystem(GTI_SYST_INFO *pSystInfo);
GTI_WORD Gti_LocalBusDspLoad(GTI_XCVR_INFO* pXcvrInfo, GTI_WORD wMode,
    GTI_CONST_BYTE_ORDER GTI_ADDRESS_QUAL *pBuffer, GTI_WORD wSize, GTI_WORD *wLoadedIdx);
GTI_CHIP_INFO *Gti_GetLbusFirstChipInfo(GTI_LBUS_INFO *pLbusInfo);
GTI_CHIP_INFO *Gti_GetLbusNextChipInfo(GTI_LBUS_INFO *pLbusInfo, GTI_CHIP_INFO *pChipInfo);
#endif

#if (defined (GTI_DSPOCTANE) || defined (GTI_DSPVIKING) )
GTI_WORD Gti_ExtMemoryAccess(GTI_XCVR_INFO* pXcvrInfo, GTI_WORD wMemType,  GTI_BYTE bMemPage,
    GTI_WORD wAddr, GTI_WORD wSize, GTI_BYTE GTI_ADDRESS_QUAL *pBuffer);
void Gti_ReconfigureChip(GTI_CHIP_INFO *pChipInfo);
void Gti_ReconfigureXcvr(GTI_XCVR_INFO *pXcvrInfo);
void Gti_ReconfigureSystem1(GTI_SYST_INFO *pSystInfo);
void Gti_ReconfigureSystem2(GTI_SYST_INFO *pSystInfo);
void Gti_ReconfigureSystem3(GTI_SYST_INFO *pSystInfo);
void Gti_ReconfigureSystem(GTI_SYST_INFO *pSystInfo);
#endif /* Octane || Viking */

#ifdef GTI_DSPVIKING
GTI_DWORD Gti_ReadVikingRegister(GTI_XCVR_INFO* pXcvr, GTI_WORD addr );
#endif /* Viking */

#endif /* INCLUDE_FILE_GTIEXTN_H */
