#include "gti_rel.h"

/*
 *	Change version number and copyright years here ONLY.
 */
#define    GUSB_MAJOR_VERSION    1
#define    GUSB_MINOR_VERSION    01
#define    GUSB_BUILD_NUMBER     0011
#define    GUSB_QFE_NUMBER       0000
#define    GUSB_RELEASE_TYPE     GUSB_RELEASE_TYPE_ENG

#ifdef ANNEXA
#define    GUSB_ANNEX_TYPE       GUSB_ANNEX_A
#endif

#ifdef ANNEXB
#define    GUSB_ANNEX_TYPE       GUSB_ANNEX_B
#endif

#ifdef ANNEXC
#define    GUSB_ANNEX_TYPE       GUSB_ANNEX_C
#endif

#define    GUSB_COPYRIGHT_YRS    "2000-2003"

/*
 *	End of Driver version and copyright years update section.
 *	All version changes should be done in the paragraph above.
 */

#define    GUSB_RELEASE_TYPE_QA   "Q"
#define    GUSB_RELEASE_TYPE_ENG  "E"
#define    GUSB_RELEASE_TYPE_WHQL "W"

#define    GUSB_ANNEX_A          "A"
#define    GUSB_ANNEX_B          "B"
#define    GUSB_ANNEX_C          "C"

#define    MAKE_VERSION_STRING2(a,b,c)      #a "." #b "." #c 
#define    MAKE_VERSION_STRING(a,b,c)       MAKE_VERSION_STRING2(a,b,c)

#define    GUSB_FIRMWARE_VERSION   RELEASE
#define    GUSB_FILE_VERSION     MAKE_VERSION_STRING(GUSB_MAJOR_VERSION, GUSB_MINOR_VERSION, GUSB_BUILD_NUMBER) GUSB_RELEASE_TYPE "-" GUSB_ANNEX_TYPE
#define    GUSB_COMPANY_NAME     "GlobespanVirata Inc."
#define    GUSB_DESCRIPTION      "USB ADSL Driver"
#define    GUSB_LEGAL_COPYRIGHT  "Copyright \251 " GUSB_COMPANY_NAME " " GUSB_COPYRIGHT_YRS 
#if defined (LAN_MINIPORT)
#define    GUSB_FILE_NAME        "glausb.sys"
#define    GUSB_PRODUCT_NAME     "GlobespanVirata LAN ADSL USB Modem"
#elif defined (WAN_MINIPORT)
#define    GUSB_FILE_NAME        "gwausb.sys"
#define    GUSB_PRODUCT_NAME     "GlobespanVirata WAN ADSL USB Modem"
#define    GUSB_DEVICE_NAME      "DSLWanUsb"
#elif defined (ATM_MINIPORT)
#define    GUSB_FILE_NAME        "gaausb.sys"
#define    GUSB_PRODUCT_NAME     "GlobespanVirata ATM ADSL USB Modem"
#endif
