////////////////////////////////////////////////////////////////////////////////
//
// INTEL CORPORATION PROPRIETARY INFORMATION               
// This software is supplied under the terms of a license agreement 
// or non-disclosure agreement with Intel Corporation and may not be 
// copied nor disclosed except in accordance with the terms of that 
// agreement.                               
// Copyright  1998 Intel Corporation. All Rights Reserved.
//
// PVCS Information:
//     $WorkFile$
//     $Revision: 1.1 $
//     $Modtime: 8/06/01 4:02p $
//     $Author: kattre $
//
// ABSTRACT:
//	   Contains data structures, function declarations, and macros for the
//     CRC module
//
////////////////////////////////////////////////////////////////////////////////
#ifndef CRC_H
#define CRC_H

//------------------------------------------------------------------------------
//
// CRC algorithm related constants
//
//------------------------------------------------------------------------------
#define CRC_INITIAL_VALUE  0xFFFFFFFF
#define CRC_RESIDUE        0xC704DD7B

//------------------------------------------------------------------------------
//
// Function Declarations
//
//------------------------------------------------------------------------------
void 
CrcGenerateTable( void);

ULONG
CrcCalculate(
   PUCHAR	Cell,
   UCHAR	Length,
   ULONG	Crc);


#endif // CRC_H

